<?php
/**
* This file is part of the Agora-Project Software package.
*
* @copyright (c) Agora-Project Limited <https://www.agora-project.net>
* @license GNU General Public License, version 2 (GPL-2.0)
*/


/*
 * Controleur du module "Calendar"
 */
class CtrlCalendar extends Ctrl
{
	const moduleName="calendar";
	public static $moduleOptions=["ajout_agenda_ressource_admin","ajout_categorie_admin"];
	public static $MdlObjects=array("MdlCalendar","MdlCalendarEvent");

	/*
	 * ACTION PAR DEFAUT
	 */
	public static function actionDefault()
	{
		////	AGENDAS VISIBLES (TOUS?)  &&  AGENDAS AFFICHES  &&  EVT PROPOSÉS
		if(empty($_SESSION["displayAllCals"]) || Req::isParam("displayAllCals"))	{$_SESSION["displayAllCals"]=(Req::getParam("displayAllCals")==1 && Ctrl::$curUser->isAdminGeneral())  ?  true  :  false;}
		$vDatas["visibleCalendars"]=($_SESSION["displayAllCals"]==true)  ?  MdlCalendar::affectationCalendars()  :  MdlCalendar::visibleCalendars();
		$vDatas["displayedCalendars"]=MdlCalendar::displayedCalendars($vDatas["visibleCalendars"]);
		$vDatas["menuProposedEvents"]=self::menuProposedEvents();
		////	MODE D'AFFICHAGE (day / 3Days / workWeek / week / month)  &  TEMPS DE RÉFÉRENCE  &  JOURS FÉRIÉS
		$displayMode=self::prefUser("calendarDisplayMode","displayMode");
		if(empty($displayMode))  {$displayMode=(Tool::isMobile()) ? "3Days":"month";}
		$vDatas["displayMode"]=$displayMode;
		$vDatas["curTime"]=$curTime=(Req::isParam("curTime")) ? Req::getParam("curTime") : time();
		$vDatas["celebrationDays"]=Trad::celebrationDays(date("Y",$curTime));
		////	AFFICHAGE : PREPARE LES TIMES/DATES, 
		//AFFICHAGE MOIS
		if($displayMode=="month"){
			$vDatas["timeBegin"]=strtotime(date("Y-m",$curTime)."-01 00:00");
			$vDatas["timeEnd"]  =strtotime(date("Y-m",$curTime)."-".date("t",$curTime)." 23:59");
			$vDatas["timePrev"]=strtotime("-1 month",$curTime);
			$vDatas["timeNext"]=strtotime("+1 month",$curTime);
			$vDatas["timeDisplayedBegin"]=strtotime("-".(date("N",$vDatas["timeBegin"])-1)." days", $vDatas["timeBegin"]);//Commence tjs par un lundi. Si le mois commence par un mercredi, on enlève 2 jours pour le lundi/mardi du mois précédent
			$vDatas["timeDisplayedEnd"]=strtotime("+".(7-date("N",$vDatas["timeEnd"]))." days", $vDatas["timeEnd"]);	  //Termine tjs l'affichage par un dimanche. Idem mais pour la fin du mois
		}
		//AFFICHAGE SEMAINE / SEMAINE DE TRAVAIL
		elseif(preg_match("/week/i",$displayMode)){
			$weekTimeBegin=strtotime("-".(date("N",$curTime)-1)." days",$curTime);//lundi=0 => dimanche=6
			$weekTimeEnd=($displayMode=="week") ? strtotime("+6 days",$weekTimeBegin) : strtotime("+4 days",$weekTimeBegin);
			$vDatas["timeBegin"]=strtotime(date("Y-m-d",$weekTimeBegin)." 00:00");
			$vDatas["timeEnd"]	=strtotime(date("Y-m-d",$weekTimeEnd)." 23:59");
			$vDatas["timePrev"]=strtotime("-1 week",$curTime);
			$vDatas["timeNext"]=strtotime("+1 week",$curTime);

		}
		//AFFICHAGE 3 PROCHAINS JOURS
		elseif($displayMode=="3Days"){
			$vDatas["timeBegin"]=strtotime(date("Y-m-d",$curTime)." 00:00");
			$vDatas["timeEnd"]	=$vDatas["timeBegin"]+259199;//259199 = 3 jours - 1sec
			$vDatas["timePrev"]=strtotime("-3 day",$curTime);
			$vDatas["timeNext"]=strtotime("+3 day",$curTime);
		}
		//AFFICHAGE JOUR
		elseif($displayMode=="day"){
			$vDatas["timeBegin"]=strtotime(date("Y-m-d",$curTime)." 00:00");
			$vDatas["timeEnd"]	=strtotime(date("Y-m-d",$curTime)." 23:59");
			$vDatas["timePrev"]=strtotime("-1 day",$curTime);
			$vDatas["timeNext"]=strtotime("+1 day",$curTime);
			
		}
		////	LIBELLES ET MENU DE LA PERIODE DE L'AGENDA
		//Libellés "month"
		if($displayMode=="month")
		{
			//Exple "mars 2016"
			$vDatas["labelPeriod"]=ucfirst(Txt::formatime("%B %Y",$curTime));
			//Menu pour changer d'année et de mois
			$vDatas["calMonthPeriodMenu"]=null;
			for($tmpMonth=1; $tmpMonth<=12; $tmpMonth++){
				$tmpMonthTime=strtotime(date("Y",$curTime)."-".($tmpMonth>9?$tmpMonth:"0".$tmpMonth)."-01");
				$vDatas["calMonthPeriodMenu"].="<a onClick=\"redir('?ctrl=calendar&curTime=".$tmpMonthTime."')\" ".(date("Y-m",$curTime)==date("Y-m",$tmpMonthTime)?"class='sLinkSelect'":null).">".Txt::formatime("%B",$tmpMonthTime)."</a>";
			}
			$vDatas["calMonthPeriodMenu"].="<hr>";
			for($tmpYear=date("Y")-3; $tmpYear<=date("Y")+5; $tmpYear++){
				$tmpYearTime=strtotime($tmpYear."-".date("m",$curTime)."-01");
				$vDatas["calMonthPeriodMenu"].="<a onClick=\"redir('?ctrl=calendar&curTime=".$tmpYearTime."')\" ".(date("Y",$curTime)==$tmpYear?"class='sLinkSelect'":null).">".$tmpYear."</a>";
			}
		}
		//Autres libellés
		else
		{
			//exple "semaine 44"
			$titleLabelPeriod=Txt::trad("CALENDAR_displayWeek")." ".date("W",$vDatas["timeBegin"]);
			if($displayMode=="day"){//exple "26 oct. 2015"
				$vDatas["labelPeriod"]="<span title=\"".$titleLabelPeriod."\">".Txt::formatime("%e %b %Y",$curTime)."</span>";
			}else{//exple "20 - 27 nov. 2015"	
				$beginMonthLabel=(date("m",$vDatas["timeBegin"])!=date("m",$vDatas["timeEnd"]))  ?  Txt::formatime("%b",$vDatas["timeBegin"])  :  null;//Si besoin, affiche le mois du début ET le mois de la fin de période
				$vDatas["labelPeriod"]="<span title=\"".$titleLabelPeriod."\">".strftime("%e",$vDatas["timeBegin"])." ".$beginMonthLabel." - ".Txt::formatime("%e %b %Y",$vDatas["timeEnd"])."</span>";
			}
		}
		////	LISTE LES JOURS À AFFICHER
		$vDatas["periodDays"]=[];
		if(empty($vDatas["timeDisplayedBegin"]))	{$vDatas["timeDisplayedBegin"]=$vDatas["timeBegin"];  $vDatas["timeDisplayedEnd"]=$vDatas["timeEnd"];}
		for($timeDay=$vDatas["timeDisplayedBegin"]+43200; $timeDay<=$vDatas["timeDisplayedEnd"]; $timeDay+=86400)//43200sec de décalage : heures d'été/hivers
		{
			//Date/Timestamp de début et fin du jour (attention aux heures d'été/hivers)  &&  Class spécifique si avant/apres le mois affiché ou c'est une date
			$tmpDay["date"]=date("Y-m-d",$timeDay);
			$tmpDay["timeBegin"]=strtotime(date("Y-m-d",$timeDay)." 00:00");
			$tmpDay["timeEnd"]=strtotime(date("Y-m-d",$timeDay)." 23:59");
			//Class css de la cellule du jour : Jours passés ou jours du futur mois  /  Aujourd'hui  /  Jour normal
			if($tmpDay["timeEnd"]<time() || ($displayMode=="month" && date("m",$timeDay)!=date("m",$curTime)))	{$tmpDay["dayClass"]="vCalMonthDayOpacity";}
			elseif(date("Y-m-d",$timeDay)==date("Y-m-d"))														{$tmpDay["dayClass"]="vCalMonthToday";}
			else																								{$tmpDay["dayClass"]=null;}
			//Url d'ajout d'evt pour le jour (vue mois) / Libelle de jour ferie / Aujourd'hui?
			$tmpDay["urlEditNew"]=MdlCalendarEvent::getUrlNew()."&newEvtTimeBegin=".strtotime(date("Y-m-d",$tmpDay["timeBegin"])." ".date("H:00",time()+3600));//Date du jour à afficher, mais avec la prochaine heure courante
			$tmpDay["celebrationDay"]=(array_key_exists(date("Y-m-d",$timeDay),$vDatas["celebrationDays"]))  ?  $vDatas["celebrationDays"][date("Y-m-d",$timeDay)]  :  null;
			//Ajoute les infos du jour
			$vDatas["periodDays"][]=$tmpDay;
		}
		////	VUE "MONTH"/"WEEK" DE CHAQUE AGENDA
		foreach($vDatas["displayedCalendars"] as $cptCal=>$tmpCal)
		{
			//init
			$vDatas2=$vDatas;
			$vDatas2["tmpCal"]=$tmpCal;
			$vDatas2["cptCal"]=$cptCal;
			$vDatas2["txtAddEvt"]=($displayMode=="month") ? Txt::trad("CALENDAR_addEvtDay") : Txt::trad("CALENDAR_addEvtHour");//"ajouter un événement"
			$vDatas2["txtAddEvtPropose"]=($tmpCal->editRight()==false) ? " (".Txt::trad("CALENDAR_propose").")" : null;//"(proposition)"
			//LISTE DES EVENEMENTS DE CHAQUE JOUR
			$vDatas2["eventList"]=[];
			$tmpCal->displayedPeriodEvtList=$tmpCal->evtList($vDatas["timeDisplayedBegin"],$vDatas["timeDisplayedEnd"]);//Evenements de l'agenda, sur la période affichee
			foreach($vDatas["periodDays"] as $dayCpt=>$tmpDay)
			{
				//Ajoute la liste des evts du jour dans l'agenda courant
				$vDatas2["eventList"][$tmpDay["date"]]=[];
				$tmpCalDisplayedDayEvtList=MdlCalendar::periodEvts($tmpCal->displayedPeriodEvtList,$tmpDay["timeBegin"],$tmpDay["timeEnd"]);//Sélectionne uniquement les evenements sur la journée
				foreach($tmpCalDisplayedDayEvtList as $tmpEvt)
				{
					//Evt hors catégorie?
					if(Req::isParam("_idCatFilter") && $tmpEvt->_idCat!=Req::getParam("_idCatFilter"))	{continue;}
					//Element pour l'affichage "semaine"/"jour"
					if($displayMode!="month")
					{
						//Duree / Hauteur à afficher pour l'evt
						$tmpEvt->dayCpt=$dayCpt;
						$tmpEvt->timeBegin=strtotime($tmpEvt->dateBegin);
						$tmpEvt->timeEnd=strtotime($tmpEvt->dateEnd);
						$evtBeforeTmpDay=($tmpEvt->timeBegin < $tmpDay["timeBegin"]);//Evt commence avant le jour courant ?
						$evtAfterTmpDay=($tmpEvt->timeEnd > $tmpDay["timeEnd"]);	 //Evt termine après le jour courant?
						if($evtBeforeTmpDay==true && $evtAfterTmpDay==true)	{$tmpEvt->durationMinutes=24*60;}										//Affiche toute la journée
						elseif($evtBeforeTmpDay==true)						{$tmpEvt->durationMinutes=($tmpEvt->timeEnd-$tmpDay["timeBegin"])/60;}	//Affiche l'evt depuis 0h00 du jour courant
						elseif($evtAfterTmpDay==true)						{$tmpEvt->durationMinutes=($tmpDay["timeEnd"]-$tmpEvt->timeBegin)/60;}	//Affiche l'evt jusqu'à 23h59 du jour courant
						else												{$tmpEvt->durationMinutes=($tmpEvt->timeEnd-$tmpEvt->timeBegin)/60;}	//Affichage normal (au cour de la journée)
						//Heure/Minutes de début d'affichage ("evtBeforeDayBegin" si l'evt a commencé avant le jour affiché)
						$tmpEvt->minutesFromDayBegin=($tmpEvt->timeBegin>$tmpDay["timeBegin"])  ?  (($tmpEvt->timeBegin-$tmpDay["timeBegin"])/60)  :  "evtBeforeDayBegin";
					}
					//AJOUTE L'EVT!
					$vDatas2["eventList"][$tmpDay["date"]][]=$tmpEvt;
				}
			}
			$calendarVue=($displayMode=="month")?"VueCalendarMonth.php":"VueCalendarWeek.php";
			$tmpCal->calendarVue=self::getVue(Req::getCurModPath().$calendarVue, $vDatas2);
		}
		////	SYNTHESE DES AGENDAS (SI + D'UN AGENDA)
		if(count($vDatas["displayedCalendars"])>1 && !Tool::isMobile())
		{
			//Jours à afficher pour la synthese
			$vDatas["periodDaysSynthese"]=[];
			foreach($vDatas["periodDays"] as $tmpDay)
			{
				//affichage "month" & jour d'un autre mois : passe le jour
				if($displayMode=="month" && date("m",$tmpDay["timeBegin"])!=date("m",$curTime))	{continue;}
				//Evénements de chaque agenda pour le $tmpDay 
				$nbCalsOccuppied=0;
				$tmpDay["calsEvts"]=[];
				foreach($vDatas["displayedCalendars"] as $tmpCal){
					$tmpDay["calsEvts"][$tmpCal->_id]=MdlCalendar::periodEvts($tmpCal->displayedPeriodEvtList,$tmpDay["timeBegin"],$tmpDay["timeEnd"]);
					if(!empty($tmpDay["calsEvts"][$tmpCal->_id]))	{$nbCalsOccuppied++;}
				}
				//Tooltip de synthese si au moins un agenda possède un événement à cette date
				$tmpDay["nbCalsOccuppied"]=(!empty($nbCalsOccuppied))  ?  Txt::displayDate($tmpDay["timeBegin"],"full")." :<br>".Txt::trad("CALENDAR_calendarsPercentBusy")." : ".$nbCalsOccuppied." / ".count($tmpDay["calsEvts"])  :  null;
				//Ajoute le jour
				$vDatas["periodDaysSynthese"][]=$tmpDay;
			}
		}
		////	LANCE L'AFFICHAGE
		static::$isMainPage=true;
		static::displayPage("VueIndex.php",$vDatas);
	}

	/*
	 * Agenda courant est affiché?
	 */
	public static function isDisplayedCal($displayedCalendars, $curCal)
	{
		foreach($displayedCalendars as $tmpCal){
			if($tmpCal->_id==$curCal->_id)  {return true;}
		}
	}

	/*
	 * PLUGINS
	 */
	public static function plugin($pluginParams)
	{
		$pluginsList=$eventList=[];
		if($pluginParams["type"]=="search" || $pluginParams["type"]=="dashboard")
		{
			//"Mes agendas" si on est sur le dashboard / "Agendas visibles" si c'est la recherche
			$visibleCalendars=($pluginParams["type"]=="dashboard") ? MdlCalendar::myCalendars() : MdlCalendar::visibleCalendars();
			if(!empty($visibleCalendars))
			{
				////	Evenements à confirmer
				if($pluginParams["type"]=="dashboard")
				{
					$menuProposedEvents=self::menuProposedEvents();
					if(!empty($menuProposedEvents)){
						$objMenuConfirm=new stdClass();
						$objMenuConfirm->pluginModule=self::moduleName;
						$objMenuConfirm->pluginSpecificMenu=$menuProposedEvents;
						$pluginsList[]=$objMenuConfirm;
					}
				}
				////	Evenements de chaque agenda : événements courants
				if($pluginParams["type"]=="dashboard")
				{
					foreach($visibleCalendars as $tmpCal)
					{
						//Tous les Evt avec accessRight>=1, trié par date (et non par H:M)
						$tmpCalEvtList=$tmpCal->evtList(null,null,1,false);
						//Filtre des Evts pour une période de plusieurs jours
						$tmpCalEvtListFull=[];
						$dateTimeBegin=strtotime($pluginParams["dateTimeBegin"])+43200;//Décale de 12h pour les heures d'été/hivers
						$dateTimeEnd=strtotime($pluginParams["dateTimeEnd"]);
						//Récupère les evt pour chaque jour de la période
						for($timeDay=$dateTimeBegin; $timeDay<=$dateTimeEnd; $timeDay+=86400){
							$subPeriodBegin=strtotime(date("Y-m-d",$timeDay)." 00:00");
							$subPeriodEnd=strtotime(date("Y-m-d",$timeDay)." 23:59");
							$tmpCalEvtListFull=array_merge($tmpCalEvtListFull, MdlCalendar::periodEvts($tmpCalEvtList,$subPeriodBegin,$subPeriodEnd));
						}
						//Ajoute à la liste des evt
						foreach($tmpCalEvtListFull as $tmpEvt)  {$tmpEvt->pluginIsCurrent=true;  $eventList[]=$tmpEvt;}
					}
				}
				////	Evenements de chaque agenda : sélection normale du plugin (date de création OU recherche)
				foreach($visibleCalendars as $tmpCal){
					$eventList=array_merge($eventList, $tmpCal->evtList(null,null,1,false,$pluginParams));//Tous les Evt avec accessRight>=1, pas triés par H:M et filtrés avec $pluginParams
				}
				$eventList=array_unique($eventList,SORT_REGULAR);
				////	Ajoute les plugins
				foreach($eventList as $tmpEvt)
				{
					if($tmpEvt->readRight())
					{
						$tmpEvt->pluginModule=self::moduleName;
						$tmpEvt->pluginIcon=(isset($tmpEvt->pluginIsCurrent) && $pluginParams["type"]=="dashboard") ? "newObj2.png" : "calendar/icon.png";
						$tmpEvt->pluginLabel=Txt::displayDate($tmpEvt->dateBegin,"normal",$tmpEvt->dateEnd)." : ".$tmpEvt->title;
						$tmpEvt->pluginTitle=Txt::displayDate($tmpEvt->dateBegin,"full",$tmpEvt->dateEnd)."<br>".$tmpEvt->affectedCalendarsLabel();
						$tmpEvt->pluginJsIcon="redir('".$tmpEvt->getUrl("container")."',true);";//"datetime" & "displayType" (month/week/day)
						$tmpEvt->pluginJsLabel="lightboxOpen('".$tmpEvt->getUrl("vue")."');";
						$pluginsList[]=$tmpEvt;
					}
				}
			}
		}
		return $pluginsList;
	}

	/*
	 * ACTION : Evenements que l'user courant a créé
	 */
	public static function actionMyEvents()
	{
		$vDatas["myEvents"]=Db::getObjTab("calendarEvent","SELECT * FROM ap_calendarEvent WHERE _idUser=".Ctrl::$curUser->_id." ORDER BY dateBegin");
		static::displayPage("VueMyEvents.php",$vDatas);
	}

	/*
	 * ACTION : Edition d'un agenda
	 */
	public static function actionCalendarEdit()
	{
		//Init
		$curObj=Ctrl::getTargetObj();
		$curObj->controlEdit();
		if(MdlCalendar::addCalendarRight()==false)  {self::noAccessExit();}
		////	Formulaire validé
		if(Req::isParam("formValidate")){
			//Enregistre & recharge l'objet
			$timeSlot=Req::getParam("timeSlotBegin")."-".Req::getParam("timeSlotEnd");
			$typeCalendar=$curObj->isNew() ? ", type='ressource'" : null;
			$curObj=$curObj->createUpdate("title=".Db::formatParam("title").", description=".Db::formatParam("description").", timeSlot=".Db::format($timeSlot).$typeCalendar);
			static::lightboxClose();
		}
		////	Affiche la vue
		$vDatas["curObj"]=$curObj;
		static::displayPage("VueCalendarEdit.php",$vDatas);
	}

	/*
	 * ACTION : Edition d'un evenement d'agenda
	 */
	public static function actionCalendarEventEdit()
	{
		//Init
		$curObj=Ctrl::getTargetObj();
		$curObj->controlEdit();
		////	Formulaire validé
		if(Req::isParam("formValidate"))
		{
			//Modifie les détails uniquement si on a les droits complets
			if($curObj->fullRight())
			{
				//Prépare les dates
				$dateBegin=Txt::formatDate(Req::getParam("dateBegin")." ".Req::getParam("timeBegin"), "inputDatetime", "dbDatetime");
				$dateEnd=Txt::formatDate(Req::getParam("dateEnd")." ".Req::getParam("timeEnd"), "inputDatetime", "dbDatetime");
				///périodicité
				$periodDateEnd=$periodValues=$periodDateExceptions=null;
				if(Req::isParam("periodType")){
					$periodDateEnd=Txt::formatDate(Req::getParam("periodDateEnd"), "inputDate", "dbDate");
					$periodValues=Txt::tab2txt(Req::getParam("periodValues_".Req::getParam("periodType")));
					if(Req::isParam("periodDateExceptions")){
						$periodDateExceptions=[];
						foreach(Req::getParam("periodDateExceptions") as $tmpDate)  {$periodDateExceptions[]=Txt::formatDate($tmpDate,"inputDate","dbDate");}
					}
				}
				//Enregistre & recharge l'objet
				$curObj=$curObj->createUpdate("title=".Db::formatParam("title").", description=".Db::formatParam("description","editor").", dateBegin=".Db::format($dateBegin).", dateEnd=".Db::format($dateEnd).", _idCat=".Db::formatParam("_idCat").", important=".Db::formatParam("important").", contentVisible=".Db::formatParam("contentVisible").", periodType=".Db::formatParam("periodType").", periodValues=".Db::format($periodValues).", periodDateEnd=".Db::format($periodDateEnd).", periodDateExceptions=".Db::formatTab2txt($periodDateExceptions));
			}
			//Si besoin, réinitialise les affectations aux agendas : uniquement ceux sur lesquels on peut éditer les événements
			if($curObj->isNewlyCreated()==false && Req::isParam("calAffectReinit")){
				foreach(Req::getParam("calAffectReinit") as $_idCal)  {$curObj->deleteAffectation($_idCal);}
			}
			//Attribue les affectations aux agendas et propositions (uniquement ceux sur lesquels on peut éditer les événements)
			$allAffectations=[];
			if(Req::isParam("affectationCalendars"))	{$allAffectations=Req::getParam("affectationCalendars");}
			if(Req::isParam("proposedCalendars"))		{$allAffectations=array_merge($allAffectations,Req::getParam("proposedCalendars"));}
			foreach($allAffectations as $idCal)
			{
				$tmpCal=Ctrl::getObj("calendar",$idCal);
				if(in_array($tmpCal,MdlCalendar::affectationCalendars())){
					$confirmed=(Req::isParam("affectationCalendars") && in_array($idCal,Req::getParam("affectationCalendars")))  ?  1  :  0;
					Db::query("INSERT INTO ap_calendarEventAffectation SET _idEvt=".$curObj->_id.", _idCal=".$tmpCal->_id.", confirmed=".Db::format($confirmed));
				}
			}
			// Invité : affiche un message "votre demande sera prise en compte prochainement"
			if(Ctrl::$curUser->isUser()==false)  {Ctrl::addNotif(Txt::trad("EDIT_demandToConfirm"));}
			//Notifie par mail & Ferme la page
			$objLabel="<b>".$curObj->title."</b> : ".Txt::displayDate($curObj->dateBegin,"full",$curObj->dateEnd)."<br>".$curObj->description;
			$tmpFilePath=self::getIcalEvents([$curObj]);
			$attachedFiles=[["path"=>$tmpFilePath, "name"=>Txt::clean($curObj->title,"maxi")."_EXPORT.ics"]];
			$curObj->sendMailNotif($objLabel, $attachedFiles);
			if(is_file($tmpFilePath))	{unlink($tmpFilePath);}
			static::lightboxClose();
		}
		////	Affiche la vue
		$vDatas["tabPeriodValues"]=Txt::txt2tab($curObj->periodValues);
		foreach(Txt::txt2tab($curObj->periodDateExceptions) as $keyTmp=>$tmpException)	{$vDatas["periodDateExceptions"][$keyTmp+1]=Txt::formatDate($tmpException,"dbDate","inputDate");}
		// Agendas d'affectations
		$vDatas["affectationCalendars"]=MdlCalendar::affectationCalendars();
		foreach($vDatas["affectationCalendars"] as $tmpCal)
		{
			//Check affectation & proposition?
			$preselectCalendar=($curObj->isNew() && $tmpCal->_id==Req::getParam("_idCal")) ? true : false;
			$tmpCal->checkAffectation=(in_array($tmpCal,$curObj->affectedCalendars(true))  || ($preselectCalendar==true && $tmpCal->editContentRight())) ? "checked" : null;	   //check si déjà affectés OU agenda présélectionné + contenu de l'agenda éditable
			$tmpCal->checkPropose	 =(in_array($tmpCal,$curObj->affectedCalendars(false)) || ($preselectCalendar==true && $tmpCal->editContentRight()==false)) ? "checked" : null;//check si déjà proposés OU agenda présélectionné + contenu de l'agenda pas éditable
			//Désactive affectation & proposition?
			$tmpCal->disableAffect =($tmpCal->editContentRight() || ($curObj->fullRight() && !empty($tmpCal->checkAffectation))) ? null  :  "disabled";	//actif si contenu de l'agenda éditable OU auteur de l'evt + agenda dejà affecté (proposition accepte)
			$tmpCal->disablePropose=($tmpCal->editContentRight() || $curObj->fullRight()) ? null : "disabled";											//actif si contenu de l'agenda éditable OU auteur de l'evt
			$tmpCal->hiddenProposeAttr =($tmpCal->disableAffect==null) ? "data-hiddenPropose='true'" : null;													//Proposition masqué si l'affectation est possible
			$tmpCal->calAffectReinit=(empty($tmpCal->disableAffect) || empty($tmpCal->disablePropose)) ? true : false;//Modif d'evt : Réinit affection si proposition ou affectation possible
			//Tooltip du label
			if(empty($tmpCal->disableAffect))		{$tmpCal->tooltip.=Txt::trad("CALENDAR_inputAffect");}	//"Ajouter l'événement [..]"
			elseif(empty($tmpCal->disablePropose))	{$tmpCal->tooltip.=Txt::trad("CALENDAR_proposeInfo");}	//"Proposer l'événement uniquement [..]"
			else									{$tmpCal->tooltip.=Txt::trad("CALENDAR_noModifInfo");}	//"Modification non autorisé [..]"
			if(!empty($tmpCal->description))  {$tmpCal->tooltip.="<br><i>".$tmpCal->description."<i>";}
		}
		//Dates d'un nouvel event
		if($curObj->isNew()){
			$curObj->dateBegin =(Req::isParam("newEvtTimeBegin"))	?  date("Y-m-d H:i", Req::getParam("newEvtTimeBegin"))	:  date("Y-m-d H:00", time()+3600);							//par défaut : date du jour, avec la prochaine heure courante
			$curObj->dateEnd   =(Req::isParam("newEvtTimeEnd"))		?  date("Y-m-d H:i", Req::getParam("newEvtTimeEnd"))	:  date("Y-m-d H:00", strtotime($curObj->dateBegin)+3600);	//par défaut : une heure après l'heure de début
		}
		$vDatas["curObj"]=$curObj;
		$vDatas["userGroups"]=MdlUserGroup::getGroups(Ctrl::$curSpace);
		static::displayPage("VueCalendarEventEdit.php",$vDatas);
	}

	/*
	 * AJAX : Control des créneaux horaires des agendas sélectionnés
	 */
	public static function actionTimeSlotBusy()
	{
		if(Req::isParam(["dateTimeBegin","dateTimeEnd","_evtId","targetObjects"]))
		{
			//Init
			$textTimeSlotBusy=null;
			$timeBegin=Txt::formatDate(Req::getParam("dateTimeBegin"),"inputDatetime","time")+1;//Décale d'une sec. pour eviter les faux positifs. Exple: créneaux 11h-12h dispo, même si 12h-13h est occupé
			$timeEnd=Txt::formatDate(Req::getParam("dateTimeEnd"),"inputDatetime","time")-1;//idem. Exple: créneaux 11h-12h dispo, même si 12h-13h est occupé
			//Vérifie le créneau horaire sur chaque agenda sélectionné
			foreach(self::getTargetObjects() as $tmpCal)
			{
				$calendarBusy=$calendarBusyTimeSlots=null;
				//Evts de l'agenda sur la période sélectionné ($accessRightMini=0.5)
				foreach(MdlCalendar::periodEvts($tmpCal->evtList($timeBegin,$timeEnd),$timeBegin,$timeEnd) as $tmpEvt){
					if($tmpEvt->_id!=Req::getParam("_evtId")){//Sauf l'evt en cours d'édition..
						$calendarBusyTimeSlots.=" &nbsp; &nbsp; <img src='app/img/arrowRight.png'> ".Txt::displayDate($tmpEvt->dateBegin,"normal",$tmpEvt->dateEnd)." ";
						$calendarBusy=true;
					}
				}
				//L'agenda est occupé?
				if($calendarBusy==true)  {$textTimeSlotBusy.="<div class='vTimeSlotBusyRow'><div class='vTimeSlotBusyCell'>".$tmpCal->title."</div><div class='vTimeSlotBusyCell'>".$calendarBusyTimeSlots."</div></div>";}
			}
			//Retourne le message
			echo $textTimeSlotBusy;
		}
	}

	/*
	 * MENU : Liste des evenements à confirmer
	 */
	public static function menuProposedEvents()
	{
		//Récupère les evenements proposés sur chaque "myCalendars()"
		$menuProposedEvents=null;
		foreach(MdlCalendar::myCalendars() as $tmpCal)
		{
			//S'il y a des propositions evenement : affiche le menu
			$eventsToConfirm=Db::getObjTab("calendarEvent","SELECT T1.* FROM ap_calendarEvent T1, ap_calendarEventAffectation T2 WHERE T1._id=T2._idEvt AND T2._idCal=".$tmpCal->_id." AND (T2.confirmed=0 or T2.confirmed is null)");
			if(count($eventsToConfirm)>0)
			{
				//Supprime les proposition d'evenements passés?
				foreach($eventsToConfirm as $tmpKey=>$tmpEvt){
					if($tmpEvt->isOldEvt(time()-86400))   {$tmpEvt->deleteAffectation($tmpCal->_id);  unset($eventsToConfirm[$tmpKey]);}
				}
				//S'il y a toujours des propositions
				if(count($eventsToConfirm)>0)
				{
					// Libelle de l'agenda
					$libConfirmEvent=($tmpCal->isMyPerso())  ?  Txt::trad("CALENDAR_evtProposedForMe")  :  Txt::trad("CALENDAR_evtProposedFor")." <i>".$tmpCal->title."</i>";
					$menuProposedEvents.="<div class='confirmEventLib'>".$libConfirmEvent." <img src='app/img/important.png'></div>";
					// Evénements à confirmer sur l'agenda
					foreach($eventsToConfirm as $tmpEvt){
						$actionJsAndId="onclick=\"confirmEventProposition(".$tmpCal->_id.",".$tmpEvt->_id.",this.id);\"  id=\"confirmEventProposition".$tmpEvt->_id."-".$tmpCal->_id."\"";
						$tooltip=htmlspecialchars($tmpEvt->title).(!empty($tmpEvt->description) ? "<hr>".Txt::reduce(strip_tags($tmpEvt->description),100) : null);
						$tooltip="title=\"".Txt::displayDate($tmpEvt->dateBegin,"full",$tmpEvt->dateEnd)."<div>".$tooltip."</div><hr>".Txt::trad("OBJECTcalendar")." : ".$tmpCal->title."<hr>".Txt::trad("CALENDAR_evtProposedBy")." ".$tmpEvt->displayAutor()."\"";
						$menuProposedEvents.="<div ".$actionJsAndId." ".$tooltip." class='confirmEventProposition sLink'><img src='app/img/arrowRight.png'> ".$tmpEvt->title."</div>";
					}
				}
			}
		}
		return $menuProposedEvents;
	}

	/*
	 * ACTION : Validation d'événement dans un Agenda
	 */
	public static function actionConfirmEventProposition()
	{
		$curCal=Ctrl::getTargetObj();
		if($curCal->confirmEventPropositionRight())
		{
			$curEvt=Ctrl::getObj("calendarEvent",Req::getParam("_idEvt"));
			if(Req::getParam("confirmed")==1)	{Db::query("UPDATE ap_calendarEventAffectation SET confirmed=1 WHERE _idEvt=".(int)$curEvt->_id." AND _idCal=".$curCal->_id);}
			else								{$curEvt->deleteAffectation($curCal->_id);}
			echo "true";
		}
	}

	/*
	 * ACTION : Détails d'un événement
	 */
	public static function actionCalendarEventVue()
	{
		$curObj=Ctrl::getTargetObj();
		$curObj->controlRead();
		// visibilite / Catégorie
		$vDatas["contentVisible"]=(preg_match("/(public_cache|prive)/i",$curObj->contentVisible))  ?  ($curObj->contentVisible=="public_cache"?Txt::trad("CALENDAR_visibilityPublicHide"):Txt::trad("CALENDAR_visibilityPrivate"))  :  null;
		$vDatas["labelCategory"]=(!empty($curObj->objCategory))  ?  $curObj->objCategory->display()  :  null;
		//Périodicité
		$vDatas["labelPeriod"]=$periodValues=null;
		if(!empty($curObj->periodType))
		{
			//Périodicité
			$vDatas["labelPeriod"]=Txt::trad("CALENDAR_period_".$curObj->periodType);
			foreach(Txt::txt2tab($curObj->periodValues) as $tmpVal){
				if($curObj->periodType=="weekDay")		{$periodValues.=Txt::trad("day_".$tmpVal).", ";}
				elseif($curObj->periodType=="month")	{$periodValues.=Txt::trad("month_".$tmpVal).", ";}
			}
			if(!empty($periodValues))	{$vDatas["labelPeriod"].=" : ".trim($periodValues, ", ");}
			//Périodicité : fin
			if(!empty($curObj->periodDateEnd))	{$vDatas["labelPeriod"].="<br>".Txt::trad("CALENDAR_periodDateEnd")." : ".Txt::displayDate($curObj->periodDateEnd,"full");}
			//Périodicité : exceptions
			if(!empty($curObj->periodDateExceptions)){
				$vDatas["labelPeriod"].="<br>".Txt::trad("CALENDAR_periodException")." : ";
				$periodDateExceptions=array_filter(Txt::txt2tab($curObj->periodDateExceptions));//"array_filter" pour enlever les valeurs vides
				foreach($periodDateExceptions as $tmpVal)	{$vDatas["labelPeriod"].=Txt::displayDate($tmpVal,"dateMini").", ";}
				$vDatas["labelPeriod"]=trim($vDatas["labelPeriod"], ", ");
			}
		}
		//Détails de l'événement
		$vDatas["curObj"]=$curObj;
		static::displayPage("VueCalendarEvent.php",$vDatas);
	}

	/*
	 * ACTION : Edition des categories d'evenements
	 */
	public static function actionCalendarEventCategoryEdit()
	{
		////	Droit d'ajouter une categorie?
		if(MdlCalendarEventCategory::addCategoryRight()==false)  {static::lightboxClose(false);}
		////	Validation de formulaire
		if(Req::isParam("formValidate")){
			$curObj=Ctrl::getTargetObj();
			$curObj->controlEdit();
			//Modif d'une categorie
			$_idSpaces=(!in_array("all",Req::getParam("spaceList")))  ?  Txt::tab2txt(Req::getParam("spaceList"))  :  null;
			$curObj->createUpdate("title=".Db::formatParam("title").", description=".Db::formatParam("description").", color=".Db::formatParam("color").", _idSpaces=".Db::format($_idSpaces));
			//Ferme la page
			static::lightboxClose();
		}
		////	Liste des categories
		$vDatas["categoriesList"]=MdlCalendarEventCategory::getCategories(true);
		$vDatas["categoriesList"][]=new MdlCalendarEventCategory();//nouvelle categorie vide
		foreach($vDatas["categoriesList"] as $tmpKey=>$tmpCategory){
			if($tmpCategory->editRight()==false)	{unset($vDatas["categoriesList"][$tmpKey]);}
			else{
				$tmpCategory->tmpId=$tmpCategory->_targetObjId;
				$tmpCategory->createdBy=($tmpCategory->isNew()==false)  ?  Txt::trad("creation")." : ".$tmpCategory->displayAutor()  :  null;
			}
		}
		////	Affiche le form
		static::displayPage("VueCalendarEventCategoryEdit.php",$vDatas);
	}

	/*
	 * Export des événements d'un agenda
	 */
	public static function actionExportEvents()
	{
		$curCalendar=Ctrl::getTargetObj();
		//Droit en édition?
		if($curCalendar->editRight())
		{
			//Récup le fichier Ical (même si aucun agendas à afficher..)
			$periodBegin=time()-(86400*365);//Time - 1 an
			$periodEnd=time()+(86400*365*5);//Time + 5 ans
			$tmpFilePath=self::getIcalEvents($curCalendar->evtList($periodBegin,$periodEnd));
			if(is_file($tmpFilePath))
			{
				$fileName=Txt::clean($curCalendar->title,"maxi")."_EXPORT_".date("d-m-Y").".ics";
				//Téléchargement du fichier / Envoi le fichier par mail
				if(Req::isParam("sendMail")==false)  {File::download($fileName,$tmpFilePath,null,false);}
				else{
					$subject=$mainMessage=ucfirst(Txt::trad("OBJECTcalendar"))." ''".$curCalendar->title."'' : ".Txt::trad("CALENDAR_exportEvtMailList");
					$mainMessage.="<br>".Txt::trad("CALENDAR_exportEvtMailInfo");
					$attachedFiles=[["path"=>$tmpFilePath, "name"=>$fileName]];
					Tool::sendMail(Ctrl::$curUser->mail, $subject, $mainMessage, null, $attachedFiles);
				}
				//Supprime le fichier
				unlink($tmpFilePath);
			}
		}
	}

	/*
	 * Création du fichier .ICAL
	 */
	public static function getIcalEvents($eventList)
	{
		//INIT
		$ical ="BEGIN:VCALENDAR\n";
		$ical.="PRODID:-//Agora-Project//".self::$agora->name."//EN\n";
		$ical.="VERSION:".VERSION_AGORA."\n";
		$ical.="CALSCALE:GREGORIAN\n";
		$ical.="METHOD:PUBLISH\n";
		//TIMEZONE
		$ical.="BEGIN:VTIMEZONE\n";
		$ical.="TZID:".self::$curTimezone."\n";
		$ical.="X-LIC-LOCATION:".self::$curTimezone."\n";
		//Daylight
		$ical.="BEGIN:DAYLIGHT\n";
		$ical.="TZOFFSETFROM:".self::icalHour()."\n";
		$ical.="TZOFFSETTO:".self::icalHour(1)."\n";
		$ical.="TZNAME:CEST\n";
		$ical.="DTSTART:19700329T020000\n";
		$ical.="RRULE:FREQ=YEARLY;INTERVAL=1;BYDAY=-1SU;BYMONTH=3\n";
		$ical.="END:DAYLIGHT\n";
		//Standard
		$ical.="BEGIN:STANDARD\n";
		$ical.="TZOFFSETFROM:".self::icalHour(1)."\n";
		$ical.="TZOFFSETTO:".self::icalHour()."\n";
		$ical.="TZNAME:CET\n";
		$ical.="DTSTART:19701025T030000\n";
		$ical.="RRULE:FREQ=YEARLY;INTERVAL=1;BYDAY=-1SU;BYMONTH=10\n";
		$ical.="END:STANDARD\n";
		$ical.="END:VTIMEZONE\n";
		//AJOUT DE CHAQUE EVENEMENT (AJOUES PLUSIEURS FOIS EN CAS DE RECCURRENCE)
		foreach($eventList as $tmpEvt)
		{
			//Infos de base
			$ical.="\nBEGIN:VEVENT\n";
			$ical.="CREATED:".self::icalDate($tmpEvt->dateCrea)."\n";
			$ical.="LAST-MODIFIED:".self::icalDate($tmpEvt->dateModif)."\n";
			$ical.="DTSTAMP:".self::icalDate(date("Y-m-d H:i"))."\n";
			$ical.="UID:".self::icalIdEvt($tmpEvt)."\n";
			$ical.="SUMMARY:".$tmpEvt->title."\n";
			$ical.="DTSTART;TZID=".self::icalDate($tmpEvt->dateBegin,true)."\n";//exple : "20050714T170000Z" pour 14 juillet 2005 à 17h00
			$ical.="DTEND;TZID=".self::icalDate($tmpEvt->dateEnd,true)."\n";
			// Périodicité : année / jours de la semaine / mois (non compatible .ics) / jours du mois (non compatible .ics)
			$periodDateEnd=($tmpEvt->periodDateEnd) ? ";UNTIL=".self::icalDate($tmpEvt->periodDateEnd) : null;
			if($tmpEvt->periodType=="year"){
				$ical.="RRULE:FREQ=YEARLY;INTERVAL=1".$periodDateEnd."\n";
			}elseif($tmpEvt->periodType=="weekDay"){
				$tmpEvt->periodValues=str_replace([1,2,3,4,5,6,7], ['MO','TU','WE','TH','FR','SA','SU'], $tmpEvt->periodValues);
				$ical.="RRULE:FREQ=WEEKLY;INTERVAL=1;BYDAY=".implode(",",Txt::txt2tab($tmpEvt->periodValues)).$periodDateEnd."\n";
			}elseif($tmpEvt->periodType=="month"){
				$tmpEvt->description.=Txt::trad("CALENDAR_period_month")." : ";
				foreach(Txt::txt2tab($tmpEvt->periodValues) as $tmpMonth)	{$tmpEvt->description.=Txt::trad("month_".$tmpMonth).", ";}
				$ical.="RRULE:FREQ=MONTHLY;INTERVAL=1".$periodDateEnd."\n";
			}
			//Description (& agendas où il est affecté) et Categorie
			if(count($tmpEvt->affectedCalendars(true))>0)  {$tmpEvt->description.=(!empty($tmpEvt->description)?" - ":null).Txt::reduce(str_replace("<br>"," ",$tmpEvt->affectedCalendarsLabel()));}
			$tmpEvt->description=str_replace(["\r","\n"], null, html_entity_decode(strip_tags($tmpEvt->description)));
			if(!empty($tmpEvt->description))	{$ical.="DESCRIPTION:".$tmpEvt->description."\n";}
			if(!empty($tmpEvt->_idCat))			{$ical.="CATEGORIES:".Ctrl::getObj("calendarEventCategory",$tmpEvt->_idCat)->title."\n";}
			$ical.="END:VEVENT\n";
		}
		//Fin du ical
		$ical.="END:VCALENDAR\n";
		//Enregistre dans un fichier temporaire
		$tmpFilePath=tempnam(sys_get_temp_dir(),"exportCalendar".uniqid());
		$fp=fopen($tmpFilePath, "w");
		fwrite($fp,$ical);
		fclose($fp);
		//renvoie le chemin du fichier tmp
		return $tmpFilePath;
	}
	/*
	 * Export .ical : formatage de l'heure
	 */
	public static function icalHour($timeLag=0)
	{
		// Exemple avec "-5:30"
		$hourTimezone=Tool::$tabTimezones[self::$curTimezone];
		$valueSign=(substr($hourTimezone,0,1)=="-") ? '-' : '+';				//"-"
		$hourAbsoluteVal=str_replace(['-','+'],null,substr($hourTimezone,0,-3));//"5"
		$hourAbsoluteVal+=$timeLag;												//Si $timeLag=2 -> "7"
		if($hourAbsoluteVal<10)	{$hourAbsoluteVal="0".$hourAbsoluteVal;}		//"05"
		$minutes=substr($hourTimezone,-2);										//"30"
		return $valueSign.$hourAbsoluteVal.$minutes;//Retourne "-0530"
	}
	/*
	 * Export .ical : formatage de la date
	 */
	public static function icalDate($dateTime, $timezone=false)
	{
		$dateTime=date("Ymd",strtotime($dateTime))."T".date("Hi",strtotime($dateTime))."00";//exple: "20151231T235900Z"
		return ($timezone==true) ? self::$curTimezone.":".$dateTime : str_replace("T000000Z","T235900Z",$dateTime."Z");
	}
	/*
	 * Export .ical : Identifiant unique d'un événement
	 */
	public static function icalIdEvt($tmpEvt)
	{
		return md5($tmpEvt->dateCrea.$tmpEvt->_id);
	}

	/*
	 * Import d'événement (format .ical) dans un agenda
	 */
	public static function actionImportEvents()
	{
		//Charge et controle
		$curCalendar=Ctrl::getTargetObj();
		$curCalendar->controlEdit();
		////	Validation de formulaire : sélection du fichier / des evt à importer
		if(Req::isParam("formValidate"))
		{
			////	PRÉPARE LE TABLEAU D'IMPORT
			if(isset($_FILES["importFile"]) && is_file($_FILES["importFile"]["tmp_name"]))
			{
				//Récupère les événements
				require("class.iCalReader.php");
				$ical=new ical($_FILES["importFile"]["tmp_name"]);
				$vDatas["eventList"]=$ical->events();
				//Formate les evenements à importer
				if(empty($vDatas["eventList"]))  {Ctrl::addNotif("Import .Ical file : formating error");}
				else
				{
					foreach($vDatas["eventList"] as $cptEvt=>$tmpEvt)
					{
						//init
						$tmpEvt["dbDateEnd"]=$tmpEvt["dbDescription"]=$tmpEvt["dbPeriodType"]=$tmpEvt["dbPeriodValues"]=$tmpEvt["dbPeriodDateEnd"]="";
						//Prépare l'evt (attention au décalage des timezones dans le fihier .ics : mais corrigé via le "strtotime()")
						$tmpEvt["dbDateBegin"]=date("Y-m-d H:i",strtotime($tmpEvt["DTSTART"]));
						if(!empty($tmpEvt["DTEND"])){
							$tmpEvt["dbDateEnd"]=date("Y-m-d H:i",strtotime($tmpEvt["DTEND"]));
							if(strlen($tmpEvt["DTEND"])==8)  {$tmpEvt["dbDateEnd"]=date("Y-m-d H:i",(strtotime($tmpEvt["DTEND"])-86400));}//Les événements "jour" sont importés avec un jour de trop (cf. exports depuis G-Calendar)
						}
						$tmpEvt["dbTitle"]=strip_tags(nl2br($tmpEvt["SUMMARY"]));
						if(!empty($tmpEvt["DESCRIPTION"]))  {$tmpEvt["dbDescription"]=strip_tags(nl2br($tmpEvt["DESCRIPTION"]));}
						//Evenement périodique
						if(!empty($tmpEvt["RRULE"]))
						{
							//init
							$rruleTab=explode(";",$tmpEvt["RRULE"]);
							//Périodique : semaine
							if(stristr($tmpEvt["RRULE"],"FREQ=WEEKLY") && stristr($tmpEvt["RRULE"],"BYDAY=")){
								$tmpEvt["dbPeriodType"]="weekDay";
								foreach($rruleTab as $rruleTmp){//Jours de la période
									if(stristr($rruleTmp,"BYDAY="))  {$tmpEvt["dbPeriodValues"]=str_replace(['BYDAY=',',','MO','TU','WE','TH','FR','SA','SU'], [null,'@@',1,2,3,4,5,6,7], $rruleTmp);}
								}
							}
							//Périodique : mois
							if(stristr($tmpEvt["RRULE"],"FREQ=MONTHLY")){
								$tmpEvt["dbPeriodType"]="month";
								$tmpEvt["dbPeriodValues"]="@@1@@2@@3@@4@@5@@6@@7@@8@@9@@10@@11@@12@@";//sélectionne tous les mois
							}
							//Périodique : année
							if(stristr($tmpEvt["RRULE"],"FREQ=YEARLY")){
								$tmpEvt["dbPeriodType"]="year";
								$tmpEvt["dbPeriodValues"]=null;
							}
							//Périodicité : Fin de périodicité
							if(stristr($tmpEvt["RRULE"],"UNTIL=")){
								foreach($rruleTab as $rruleTmp){//Fin de période
									if(stristr($rruleTmp,"UNTIL=")){
										$tmpEvt["dbPeriodDateEnd"]=substr(intval(str_replace('UNTIL=','',$rruleTmp)), 0, 8);
										$tmpEvt["dbPeriodDateEnd"]=date("Y-m-d", strtotime($tmpEvt["dbPeriodDateEnd"]));}
								}
							}
						}
						//Etat de l'événement : à importer OU dejà present (donc ne pas importer)
						$tmpEvt["isPresent"]=(Db::getVal("SELECT count(*) FROM ap_calendarEvent T1, ap_calendarEventAffectation T2 WHERE T1._id=T2._idEvt AND T2._idCal=".$curCalendar->_id." AND T1.title=".Db::format($tmpEvt["dbTitle"])." AND T1.dateBegin=".Db::format($tmpEvt["dbDateBegin"])." AND T1.dateEnd=".Db::format($tmpEvt["dbDateEnd"])) > 0)  ?  true  :  false;
						//Ajoute l'evt
						$vDatas["eventList"][$cptEvt]=$tmpEvt;
					}
				}
			}
			////	IMPORTE LES ÉVÉNEMENTS
			elseif(Req::isParam("eventList"))
			{
				//Import de chaque événement
				foreach(Req::getParam("eventList") as $tmpEvt)
				{
					//Import sélectionné?
					if(!empty($tmpEvt["checked"])){
						//Créé et enregistre l'événement
						$curObj=new MdlCalendarEvent();
						$curObj=$curObj->createUpdate("title=".Db::format($tmpEvt["dbTitle"]).", description=".Db::format($tmpEvt["dbDescription"]).", dateBegin=".Db::format($tmpEvt["dbDateBegin"]).", dateEnd=".Db::format($tmpEvt["dbDateEnd"]).", periodType=".Db::format($tmpEvt["dbPeriodType"]).", periodValues=".Db::format($tmpEvt["dbPeriodValues"]).", periodDateEnd=".Db::format($tmpEvt["dbPeriodDateEnd"]));
						//Affecte à l'agenda courant
						Db::query("INSERT INTO ap_calendarEventAffectation SET _idEvt=".$curObj->_id.", _idCal=".$curCalendar->_id.", confirmed=1");
					}
				}
				//Ferme la page
				static::lightboxClose();
			}
		}
		////	Affiche le menu d'Import/Export
		$vDatas["curCalendar"]=$curCalendar;
		static::displayPage("VueCalendarImportEvt.php",$vDatas);
	}
}