<?php
/**
* This file is part of the Agora-Project Software package.
*
* @copyright (c) Agora-Project Limited <https://www.agora-project.net>
* @license GNU General Public License, version 2 (GPL-2.0)
*/


/*
 * Controleur du module "Dashboard"
 */
class CtrlDashboard extends Ctrl
{
	const moduleName="dashboard";
	public static $moduleOptions=["ajout_actualite_admin"];
	public static $MdlObjects=array("MdlDashboardNews");

	/*
	 * ACTION PAR DEFAUT
	 */
	public static function actionDefault()
	{
		static::$isMainPage=true;
		////	Init les périodes des plugins "Dashboard"
		$vDatas["pluginPeriod"]=(Req::getParam("pluginPeriod")=="otherPeriod")  ?  "otherPeriod"  :  self::prefUser("pluginPeriod");
		if(empty($vDatas["pluginPeriod"]))	{$vDatas["pluginPeriod"]="week";}
		//depuis la dernière connexion
		$timeConnectBegin=(int)self::$curUser->previousConnection;
		$timeConnectEnd=time();
		$vDatas["pluginConnectLabel"]=strftime("%A %d %B %Y",$timeConnectBegin)." > ".Txt::trad("today");
		//jour
		$timeDayBegin=strtotime(date("Y-m-d 00:00:00"));
		$timeDayEnd=strtotime(date("Y-m-d 23:59:59"));
		$vDatas["pluginDayLabel"]=strftime("%A %d %B");
		//cette semaine
		$weekDay=str_replace("0","7",date("w")); //Jour de la semaine (1=lundi,7=dimanche)
		$timeWeekBegin=strtotime(date("Y-m-d 00:00:00"))-(86400*($weekDay-1));
		$timeWeekEnd=$timeWeekBegin+(86400*7)-1;
		$vDatas["pluginWeekLabel"]=strftime("%A %d %B",$timeWeekBegin)." > ".strftime("%A %d %B",$timeWeekEnd);
		//ce mois
		$timeMonthBegin=strtotime(date("Y-m-01 00:00:00"));
		$timeMonthEnd=strtotime(date("Y-m-t 23:59:59"));//nb de jours dans le mois
		$vDatas["pluginMonthLabel"]=strftime("%A %d %B",$timeMonthBegin)." > ".strftime("%A %d %B",$timeMonthEnd);
		//Dates de début / fin de période de la sélection
		if($vDatas["pluginPeriod"]=="connect")		{$vDatas["pluginTimeBegin"]=$timeConnectBegin;	$vDatas["pluginTimeEnd"]=$timeConnectEnd;	}
		elseif($vDatas["pluginPeriod"]=="day")		{$vDatas["pluginTimeBegin"]=$timeDayBegin;		$vDatas["pluginTimeEnd"]=$timeDayEnd;}
		elseif($vDatas["pluginPeriod"]=="week")		{$vDatas["pluginTimeBegin"]=$timeWeekBegin;		$vDatas["pluginTimeEnd"]=$timeWeekEnd;}
		elseif($vDatas["pluginPeriod"]=="month")	{$vDatas["pluginTimeBegin"]=$timeMonthBegin;	$vDatas["pluginTimeEnd"]=$timeMonthEnd;}
		else{
			$vDatas["pluginTimeBegin"]=strtotime(Txt::formatDate(Req::getParam("pluginBegin"),"inputDate","dbDate")." 00:00");
			$vDatas["pluginTimeEnd"]=strtotime(Txt::formatDate(Req::getParam("pluginEnd"),"inputDate","dbDate")." 23:59");
		}
		////	Details de la periode des plugins
		$vDatas["pluginPeriodTitle"]=Txt::trad("DASHBOARD_newElemsInfo").strftime("%A %d %B",$vDatas["pluginTimeBegin"])." &nbsp;".Txt::trad("and")."&nbsp; ".strftime("%A %d %B",$vDatas["pluginTimeEnd"]);
		$vDatas["pluginPeriodTitleCurrent"]=Txt::trad("DASHBOARD_currentElemsInfo").strftime("%A %d %B",$vDatas["pluginTimeBegin"])." &nbsp;".Txt::trad("and")."&nbsp; ".strftime("%A %d %B",$vDatas["pluginTimeEnd"]);
		////	Plugin "dashboard" de chaque module
		$vDatas["pluginsDashboard"]=$pluginObjects=[];
		$pluginParams=array("type"=>"dashboard", "dateTimeBegin"=>date("Y-m-d H:i",$vDatas["pluginTimeBegin"]), "dateTimeEnd"=>date("Y-m-d H:i",$vDatas["pluginTimeEnd"]));
		foreach(self::$curSpace->moduleList() as $tmpModule)
		{
			//Affiche les plugins du module (s'il y a une fonction "plugin" spécifique au module)
			if(method_exists($tmpModule["ctrl"],"plugin"))
			{
				//Récupère les plugins du module
				foreach($tmpModule["ctrl"]::plugin($pluginParams) as $tmpPlugin)
				{
					//On passe à l'objet suivant  :  
					if(!empty($tmpPlugin->_targetObjId)){
						//Nouvel objet déjà été affiché dans les objets "courant" (exple: evt nouveau & courant)  ||  Le conteneur de l'objet a déjà été affiché (exple: image d'un nouveau dossier)
						if(  (empty($tmpPlugin->pluginIsCurrent) && in_array($tmpPlugin->_targetObjId,$pluginObjects))  ||  (is_object($tmpPlugin->containerObj()) && in_array($tmpPlugin->containerObj()->_targetObjId,$pluginObjects)) )  {continue;}
						//Ajoute le plugin ...après
						$pluginObjects[]=$tmpPlugin->_targetObjId;
					}
					$vDatas["pluginsDashboard"][]=$tmpPlugin;
				}
			}
		}
		////	Objets News (actualités)
		$offlineNewsCount=MdlDashboardNews::displayedNews("offlineNewsCount", true);
		$vDatas["offlineNewsCount"]=(!empty($offlineNewsCount))  ?  "(".$offlineNewsCount.")"  :  null;
		$vDatas2["newsList"]=MdlDashboardNews::displayedNews("newsList", Req::getParam("offlineNews"),0);//commence la liste à "0" comme dans un "array()"
		$vDatas["vueNewsListInitial"]=self::getVue(Req::getCurModPath()."VueNewsList.php", $vDatas2);
		////	Affiche la vue
		static::displayPage("VueIndex.php",$vDatas);
	}

	/*
	 * AJAX : RECUPERE LA SUITE DES NEWS VIA L'INFINITE SCROLL
	 */
	public static function actionGetMoreNews()
	{
		$vDatas["infiniteSroll"]=true;
		$vDatas["newsList"]=MdlDashboardNews::displayedNews("newsList", Req::getParam("offlineNews"),Req::getParam("newsOffsetCpt"));
		echo self::getVue(Req::getCurModPath()."VueNewsList.php", $vDatas);
	}

	/*
	 * PLUGINS
	 */
	public static function plugin($pluginParams)
	{
		$pluginsList=array();
		if($pluginParams["type"]=="search")
		{
			foreach(MdlDashboardNews::getPluginObjects($pluginParams) as $objNews)
			{
				$objNews->pluginModule=self::moduleName;
				$objNews->pluginIcon=self::moduleName."/icon.png";
				$objNews->pluginLabel="<span onclick=\"$('.pluginNews".$objNews->_id."').toggle();\">".Txt::reduce($objNews->description)."<span>
									  <div class='pluginNews".$objNews->_id."' style='display:none;padding:10px;'>".$objNews->description."</div>";
				$objNews->pluginTitle=$objNews->displayAutor(true,true);
				$objNews->pluginJsIcon="$('.pluginNews".$objNews->_id."').toggle();";
				$objNews->pluginJsLabel=null;
				$pluginsList[]=$objNews;
			}
		}
		return $pluginsList;
	}

	/*
	 * ACTION : Edition d'une actualité
	 */
	public static function actionDashboardNewsEdit()
	{
		//Init
		$curObj=Ctrl::getTargetObj();
		$curObj->controlEdit();
		if(MdlDashboardNews::addNewsRight()==false)   {self::noAccessExit();}
		////	Formulaire validé
		if(Req::isParam("formValidate")){
			//Enregistre & recharge l'objet
			$curObj=$curObj->createUpdate("description=".Db::formatParam("description","editor").", une=".Db::formatParam("une").", offline=".Db::formatParam("offline").", dateOnline=".Db::formatParam("dateOnline","date").", dateOffline=".Db::formatParam("dateOffline","date"));
			//Notifie par mail & Ferme la page
			$curObj->sendMailNotif(Txt::reduce($curObj->description,1000));
			static::lightboxClose();
		}
		////	Affiche la vue
		$vDatas["objNews"]=$curObj;
		static::displayPage("VueDashboardNewsEdit.php",$vDatas);
	}
}
