<?php
/**
* This file is part of the Agora-Project Software package.
*
* @copyright (c) Agora-Project Limited <https://www.agora-project.net>
* @license GNU General Public License, version 2 (GPL-2.0)
*/


/*
 * Modele des actualites
 */
class MdlDashboardNews extends MdlObject
{
	const moduleName="dashboard";
	const objectType="dashboardNews";
	const dbTable="ap_dashboardNews";
	const hasAttachedFiles=true;
	const hasNotifMail=true;
	const hasUsersComment=true;
	const hasUsersLike=true;
	const htmlEditorField="description";
	public static $requiredFields=array("description");
	public static $searchFields=array("description");
	public static $sortFields=array("dateCrea@@desc","dateCrea@@asc","dateModif@@desc","dateModif@@asc","_idUser@@asc","_idUser@@desc","description@@asc","description@@desc");

	/*
	 * STATIC : Récupère les news
	 */
	public static function displayedNews($displayMode, $offlineNews=false, $newsOffsetCpt=0)
	{
		//Bascule les news "offline" ou "online" automatiquement
		if(empty($_SESSION["dashboardNewsUpdate"])){
			Db::query("UPDATE ".static::dbTable." SET offline=null WHERE UNIX_TIMESTAMP(dateOnline)>0 AND dateOnline<'".date("Y-m-d 00:00:00")."' AND (dateOffline is null or dateOffline>'".date("Y-m-d 00:00:00")."')");
			Db::query("UPDATE ".static::dbTable." SET offline='1' WHERE UNIX_TIMESTAMP(dateOffline)>0 AND dateOffline<'".date("Y-m-d 00:00:00")."'");
			$_SESSION["dashboardNewsUpdate"]=true;
		}
		//Nombre de news offline / Liste des news online/Offline
		if($displayMode=="offlineNewsCount")	{return Db::getVal("SELECT count(*) FROM ".static::dbTable." WHERE ".static::sqlDisplayedObjects()." AND offline=1");}
		else{
			$limitNb=10;//Nb de news pour chaque affichage (tester avec "5")
			$offsetNews=(int)$newsOffsetCpt * $limitNb;//début de la tranche de la liste des news
			$sqlOfflineNews=(!empty($offlineNews))  ?  "AND offline=1"  :  "AND (offline=0 or offline is null)";
			return Db::getObjTab(static::objectType, "SELECT * FROM ".static::dbTable." WHERE ".static::sqlDisplayedObjects()." ".$sqlOfflineNews." ".static::sqlSort("une desc")." LIMIT ".$limitNb." OFFSET ".$offsetNews);
		}
	}

	/*
	 * Droit d'ajouter une nouvelle news
	 */
	public static function addNewsRight()
	{
		return (Ctrl::$curUser->isAdminCurSpace() || (Ctrl::$curUser->isUser() && Ctrl::$curSpace->moduleOptionEnabled(self::moduleName,"ajout_actualite_admin")==false));
	}
}