/**
*------------------------V3---------------------------
* This file is part of the Agora-Project Software package.
*
* @copyright (c) Agora-Project Limited <https://www.agora-project.net>
* @license GNU General Public License, version 2 (GPL-2.0)
*/


/*
 * INIT LA PAGE
 */
$(function(){
	pageLoadTimestamp=Date.now();//Microtime du chargement de la page
	extendJquery();				//Surcharge des fonctions Jquery
	initTooltips();				//Initialize les infobulles (tooltip)
	initContextMenu();			//Initialise les menus contextuels
	inputControls();			//Controles de champs spécifiques (Datepickers, FileSize, etc.)
	mainPageDisplay();			//Menu flottant / largeur des blocks d'objet / clic sur les blocks d'objet / Gallerie d'image via LightBox / Etc.
});

/*
 * Surcharge des fonctions Jquery (Fonctions étendues)
 */
function extendJquery()
{
	////	Vitesse (duration) par défaut des effets : "fadeIn()", "toggle()", etc
	$.fx.speeds._default=100;

	////	Verifie l'existance d'un element
	$.fn.exist=function(){
		return (this.length>0) ? true : false;
	};
	////	Verifie si l'element n'a pas de valeur ("empty") ...et aussi s'il existe
	$.fn.isEmpty=function(){
		return (this.length==0 || this.val().length==0) ? true : false;
	};
	////	Focus sur un champs surligné en rouge
	$.fn.focusRed=function(){
		this.addClass("focusRed").focus();
	};
	////	Affichage/masquage d'element : "surcharge" de fonctions de base de Jquery
	if(inIframe())
	{
		var fadeInBASIC=$.fn.fadeIn;
		var showBASIC=$.fn.show;
		var toggleBASIC=$.fn.toggle;
		var slideToggleBASIC=$.fn.slideToggle;
		var fadeToggleBASIC=$.fn.fadeToggle;
		$.fn.fadeIn=function(){			lightboxResize();	return fadeInBASIC.apply(this,arguments); };
		$.fn.show=function(){			lightboxResize();	return showBASIC.apply(this,arguments); };
		$.fn.toggle=function(){			lightboxResize();	return toggleBASIC.apply(this,arguments); };
		$.fn.slideToggle=function(){	lightboxResize();	return slideToggleBASIC.apply(this,arguments); };
		$.fn.fadeToggle=function(){		lightboxResize();	return fadeToggleBASIC.apply(this,arguments); };
	}
}

/*
 * PAGE INIT : Init les tooltips avec Tooltipster (cf. attribut "title")
 */
function initTooltips()
{
	//Options dans une variable, pour pouvoir réinitialiser un tooltip. "multiple" pour pouvoir afficher le tooltip par défaut
	tooltipsterOptions={contentAsHTML:true, multiple:true, position:"bottom", maxWidth:400, theme:"tooltipster-shadow"};
	tooltipsterOptionsBis=jQuery.extend({},tooltipsterOptions);//Clone "tooltipsterOptions" avec "jQuery.extend()"...
	tooltipsterOptionsBis.interactive=true;//...et ajoute l'option "interactive" pour pouvoir cliquer sur les liens (descriptions de dossier & co)
	//Lance le tooltip (même responsive)
	$("[title]").not(".noTooltip,[title=''],[title*='http']").tooltipster(tooltipsterOptions);//Tooltips normaux
	$("[title*='http']").tooltipster(tooltipsterOptionsBis);//Tooltip avec liens "http"
}

/*
 * PAGE INIT : Init les menus contextuels
 * chaque launcher (icone/texte/block d'objet) doit avoir la propriété "for" correspondant à l'ID du menu  &&  une class "menuLaunch" (sauf les launcher de block d'objet) 
 */
function initContextMenu()
{
	////	Mode Normal
	if(isMobile()==false){
		////	Mouseover/Click d'un "menu launcher" (icone/texte) : affiche le menu
		$(".menuLaunch").on("mouseover click",function(event){
			event.stopPropagation();//pour pas selectionner le block ".objContainer" ou ouvrir un evt de calMonth
			showContextMenu(this,event);//Affiche le menu context
		});
		////	Affiche via Click Droit sur le block de l'objet. "Return false" pour ne pas afficher le menu du browser
		$("[for^='objContextMenu_']").on("contextmenu",function(event){  showContextMenu(this,event);  return false;  });
		////	Survol le block d'un objet : Masque les menus qui ne le concernent pas
		$("[for^='objContextMenu_']").on("mouseenter",function(){  $(".contextMenu").not("#"+this.getAttribute("for")).fadeOut();  });
		////	Quitte le menu : on le masque
		$(".contextMenu").on("mouseleave",function(){  $(this).fadeOut();  });
		////	Click dans les menus. "stopPropagation()" pour pas selectionner le ".objContainer"
		$(".contextMenu,.objMiscMenus").click(function(event){  event.stopPropagation();  });
	}
	////	Mode responsive
	else{
		////	Click d'un "menu launcher" (icone/texte) : affiche le menu
		$(".menuLaunch").on("click",function(event){
			event.stopPropagation();//pour pas selectionner le block ".objContainer" ou ouvrir un evt de calMonth
			if($("#respMenuContent").is(":visible"))	{$("#"+this.getAttribute("for")).addClass("contextMenuSubMenu").slideToggle();}	//Affiche en tant que sous-menu si le menu responsive est déjà ouvert
			else										{showRespMenu(this.getAttribute("for"), this.getAttribute("forTwo"));}			//..Sinon on affiche le menu responsive
		});
		////	Click sur le "close" du menu
		$("#respMenuClose,#respMenuBg").on("click",function(){  hideRespMenu();  });
		////	Swipe sur la page : affiche/masque le menu responsive
		responsiveSwipe();
	}
}
/*
 * Affiche un menu contextuel (mode normal)
 */
function showContextMenu(thisLauncher, event)
{
	////	Récup l'Id du menu &  Spécifie la hauteur max du menu (fonction de la hauteur de page)
	var menuId="#"+$(thisLauncher).attr("for");
	$(menuId).css("max-height", Math.round($(window).height()-30)+"px");

	////	Positionne le menu en fonction de la position du launcher survolé  OU  de la position de la souris après un click droit sur ".objContainer"
	if(event.type=="mouseover")	{var menuPosX=$(thisLauncher).position().left;				var menuPosY=$(thisLauncher).position().top;}
	else						{var menuPosX=event.pageX - $(thisLauncher).offset().left;	var menuPosY=event.pageY - $(thisLauncher).offset().top;}//".objContainer" tjs en position relative/absolute : ajuste donc la position du menu car il doit être calculé en fonction du ".objContainer" et non de la page (cf. event.pageX et event.pageY)

	////	Repositionne le menu s'il est au bord droit/bas de la page
	//Positions du menu + largeur/hauteur : bordure droite et bas du menu
	var menuRightPos =menuPosX + $(menuId).outerWidth(true);
	var menuBottomPos=menuPosY + $(menuId).outerHeight(true);
	//Parent ".objContainer" en position "relative"/"absolute" : ajoute sa position sur la page via "offset()"
	if(/(relative|absolute)/i.test($(menuId).parent().css("position"))){
		menuRightPos+=$(menuId).parent().offset().left;
		menuBottomPos+=$(menuId).parent().offset().top;
	}
	//Vérifie et ajuste si besoin la position si on est en bordure de page
	var posPageRight=$(window).width();
	var posPageBottom=$(window).height()+$(window).scrollTop();
	if(posPageRight < menuRightPos)		{menuPosX=menuPosX-(menuRightPos-posPageRight)-10;}
	if(posPageBottom < menuBottomPos)	{menuPosY=menuPosY-(menuBottomPos-posPageBottom)-10;}

	////	Positionne et affiche le menu (avec 5px de marges)  &&  Ferme les autres menus
	if(menuPosX>10)	{menuPosX-=10;}//Pas au bord de page : recentre dans le menu
	if(menuPosY>10)	{menuPosY-=10;}//idem
	$(menuId).css("left",parseInt(menuPosX)+"px").css("top",parseInt(menuPosY)+"px").fadeIn();
	$(".contextMenu").not(menuId).hide();
}
/*
 * Affiche le menu responsive
 */
function showRespMenu(forId, forTwoId)
{
	//Init
	curRespMenuOneId="#"+forId;
	curRespMenuTwoId=(typeof forTwoId=="string" && $("#"+forTwoId).exist())  ?  "#"+forTwoId  :  null;
	//Vérif bien que le menu existe
	if($(curRespMenuOneId).exist())
	{
		//Masque par défaut le conteneur "#respMenuContentOne/Two"
		$("#respMenuContentOne,#respMenuContentTwo").hide();
		//Déplace le contenu du menu dans le conteneur  ("appendTo" conserve les listeners par rapport à "html()")
		$(curRespMenuOneId+">*").appendTo("#respMenuContentOne");
		if(curRespMenuTwoId!=null)  {$(curRespMenuTwoId+">*").appendTo("#respMenuContentTwo");}
		//Affiche le menu et son contenu
		$("#respMenuBg,#respMenuMain,#respMenuContentOne,#respMenuContentTwo").show();
		//Désactive le scroll de page en arriere plan
		$("body").css("overflow","hidden");
	}
}
/*
 * Masque le menu responsive
 */
function hideRespMenu(){
	//Vérif bien que le menu est ouvert (car lancé aussi dès un swipe..)
	if($("#respMenuMain").is(":visible"))
	{
		//Masque le menu
		$("#respMenuBg,#respMenuMain,#respMenuContentOne,#respMenuContentTwo").hide();
		//Remet son contenu dans le div d'origine
		$("#respMenuContentOne>*").appendTo(curRespMenuOneId);
		if(curRespMenuTwoId!=null)  {$("#respMenuContentTwo>*").appendTo(curRespMenuTwoId);}
		//Réactive le scroll de page en arriere plan
		$("body").css("overflow","visible");
	}
}
/*
 * Swipe sur la page : affiche/masque le menu responsive
 */
function responsiveSwipe()
{
	//Debut/Fin du touch : valeurs de départ / réinit les valeurs
	document.addEventListener("touchstart",function(event){  xDown=event.touches[0].clientX;  });
	document.addEventListener("touchend",function(){  xDown=0;  });
	//Détecte le swipe
	document.addEventListener("touchmove",function(event){
		if(typeof xDown!="undefined")
		{
			//Menu des modules (appli)  ou  Menu principal (site public and co)
			if($("#headerModules").exist())			{var menuId="headerModules";}
			else if($("#headerMenuMain").exist())	{var menuId="headerMenuMain";}
			else									{var menuId=null;}
			if(menuId!=null){
				var isSwipeLeft =((xDown - event.touches[0].clientX) > 50);//50px de mouv. minimum
				var isSwipeRight=((xDown - event.touches[0].clientX) < -50);//idem
				//Swipe left à moins de 70px du bord droit : affiche le menu s'il n'est pas visible  ||  Swipe right et menu affiché : masque le menu
				if(isSwipeLeft==true && parseInt($(window).width()-xDown)<70)	{showRespMenu(menuId,"pageModMenu");}
				else if(isSwipeRight==true)										{hideRespMenu();}
			}
		}
	});
}

/*
 * Initialise les controles de champs -> Datepickers, FileSize controls, Integer, etc
 */
function inputControls()
{
	////	Marqueur de formulaire modifié, pour confirmer si besoin une sortie ("parent" si le form se trouve dans une lightbox)
	setTimeout(function(){
		$("input,select,textarea").on("change keyup",function(){ parent.confirmCloseForm=true; });
	},500);//Trigger de 500ms pour pas le déclencher via l'initialisation d'un formulaire...

	////	Init le Datepicker jquery-UI
	$(".dateInput, .dateBegin, .dateEnd").datepicker({
		dateFormat:"dd/mm/yy",
		firstDay:1,
		showOtherMonths: true,
		selectOtherMonths: true,
		onSelect:function(date){
			//Select .dateBegin -> bloque la date minimum de .dateEnd (mais pas inversement!)
			if($(this).hasClass("dateBegin"))	{$(".dateEnd").datepicker("option","minDate",date);}
			//Trigger sur le champ concerné pour continuer l'action
			$(this).trigger("change");
		}
	});

	////	Init le plugin Timepicker (jquery-UI)
	if(jQuery().timepicker){
		var timepickerMinutesStep=(isMobile())  ?  5  :  15;//Palier de 5mn en "responsive", car champs en "readonly"
		$(".timeBegin, .timeEnd").timepicker({timeFormat:"H:i", step:timepickerMinutesStep});
	}

	////	Readonly sur les datepickers et timepickers
	if(isMobile())	{$(".dateInput,.dateBegin,.dateEnd,.timeBegin,.timeEnd").attr("readonly","readonly").css("background-color","white");}

	////	Controle les dates de début/fin
	$(".dateBegin, .dateEnd, .timeBegin, .timeEnd").change(function(){
		//Masque le champ H:M?
		if($(this).hasClass("dateBegin") || $(this).hasClass("dateEnd")){
			var timeClass=$(this).hasClass("dateBegin") ? ".timeBegin" : ".timeEnd";
			if($(this).isEmpty()==false)	{$(timeClass).show();}
			else							{$(timeClass).hide();  $(timeClass).val(null);}
		}
		//Controle des date/time
		if($(".dateBegin").isEmpty()==false || $(".dateEnd").isEmpty()==false)
		{
			//Controle des "H:M"
			if($(this).hasClass("timeBegin") || $(this).hasClass("timeEnd"))
			{
				//Champ à controler
				var timeClass=$(this).hasClass("timeBegin") ? ".timeBegin" : ".timeEnd";
				//controle Regex des H:M
				var timeRegex=/^[0-2][0-9][:][0-5][0-9]$/;
				if($(timeClass).isEmpty()==false && timeRegex.test($(timeClass).val())==false){
					notify("H:m error");
					$(timeClass).val(null);
					return false;
				}
				//précise H:M de fin si vide et début précisé
				if($(".timeEnd").isEmpty())  {$(".timeEnd").val($(".timeBegin").val());}
			}
			//Début après Fin : message d'erreur
			if($(".dateBegin").isEmpty()==false && $(".dateEnd").isEmpty()==false)
			{
				var timestampBegin=$(".dateBegin").datepicker("getDate").getTime()/1000;//getTime() renvoie des millisecondes..
				var timestampEnd=$(".dateEnd").datepicker("getDate").getTime()/1000;//idem
				if($(".timeBegin").isEmpty()==false)	{var hourMinute=$(".timeBegin").val().split(":");	timestampBegin=timestampBegin + (hourMinute[0]*3600) + (hourMinute[1]*60);}
				if($(".timeEnd").isEmpty()==false)		{var hourMinute=$(".timeEnd").val().split(":");		timestampEnd=timestampEnd + (hourMinute[0]*3600) + (hourMinute[1]*60);}
				if(timestampBegin > timestampEnd)
				{
					//Date/heure de fin reculé : message d'erreur
					if($(this).hasClass("dateEnd") || $(this).hasClass("timeEnd"))	{notify(labelDateBeginEndControl);}
					//Modif la date/heure de fin ("setTimeout" pour éviter une re-modif du timePicker)
					setTimeout(function(){
						$(".dateEnd").val($(".dateBegin").val());
						$(".timeEnd").val($(".timeBegin").val());
					},500);
				}
			}
		}
	});

	////	Controle la taille des fichiers des inputs "file"
	$("input[type='file']").change(function(){
		if($(this).isEmpty()==false && this.files[0].size > valueUploadMaxFilesize){
			$(this).val("");
			notify(labelUploadMaxFilesize);
		}
	});

	////	Affecte une couleur à un input "select" (chaque option doit avoir un attribut "data-color")
	$("select option").each(function(){
		if(this.getAttribute("data-color"))  {$(this).css("background-color",this.getAttribute("data-color")).css("color","#fff");}
	});
	$("select").change(function(){
		var optionColor=$(this).find("option:selected").attr("data-color");
		if(isEmptyValue(optionColor)==false)	{$(this).css("background-color",optionColor).css("color","#fff");}
		else									{$(this).css("background-color","#fff").css("color","#000");}
	});
	
	////	Pas d'autocomplétion sur les inputs "Password"
	$("input[type='password']").attr("autocomplete","off");
}

/*
 * Controle s'il s'agit d'un mail
 */
function isMail(mail)
{
	var mailRegex=/^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
	return mailRegex.test(mail);
}

/*
 * Cherche une expression dans une chaine de caracteres
 */
function find(needle, haystack)
{
	//Convertir en texte puis en minuscule : recherche la position de needle dans haystack
	if(typeof haystack!="undefined")	{return (haystack.toString().toLowerCase().indexOf( needle.toString().toLowerCase() ) >= 0) ? true : false;}
}

/*
 * Affiche un message de notification (via le plugin Jquery "toastmessage")
 */
function notify(message, typeNotif)
{
	//Type de notification :  "success" vert  /  "warning" jaune  /  "info" bleu (par défaut)
	var typeNotif=(typeof typeNotif!="undefined")  ?  typeNotif  :  "notice";
	//Temps d'affichage de la notification  (1 seconde pour 10 caracteres & 5 secondes minimum)
	var stayTime=parseInt(message.length/10);
	if(stayTime<5)  {stayTime=5;}
	//Affiche la notification
	parent.$().toastmessage("showToast",{
		text		: message,
		type		: typeNotif,
		position	: "top-center",
		stayTime	: (stayTime*1000)//stayTime en microsecondes
	});
}

/*
 * Redirection page
 */
function redir(adress, redirMainPage)
{
	//On annule la fermeture d'un formulaire en cours d'édition ?
	if(dontConfirmCloseForm())  {return false;}
	//Redirection de la page principale OU d'une lightbox
	if(redirMainPage===true)	{window.parent.location.href=adress;}
	else						{window.location.href=adress;}
}

/*
 * On annule la fermeture d'un formulaire en cours d'édition ?
 */
function dontConfirmCloseForm()
{
	//On doit demander la sortie de formulaire ?
	if(typeof confirmCloseForm!="undefined" && confirmCloseForm==true){
		if(confirm(labelConfirmCloseForm))	{confirmCloseForm=false;}	//On quitte le formulaire, puis réinit le "confirmCloseForm" pour éviter un nouveau "confirm()" via un "redir()"
		else								{return true;}				//Retourne "true" si la sortie n'est pas confirmée : On reste donc sur le formulaire
	}
}

/*
 * Lancé depuis une iframe ?
 */
function inIframe()
{
	return (window.parent && window.parent.location!=window.location);
}

/*
 * Ouvre une lightbox via une fonction (et non des "href" : plus souple + n'interfère pas avec "stopPropagation()" des "contextMenu")
 * tests : edit object, open pdf/mp3, open mp4/webm, open userMap, open inline html
 */
function lightboxOpen(urlSrc)
{
	////	DEPUIS LIGHTBOX / PDF EN RESPONSIVE OU DEPUIS IE
	if(inIframe())																			{parent.lightboxOpen(urlSrc);}
	else if(/\.pdf/i.test(urlSrc) && (isMobile() || find("Trident",navigator.appVersion)))	{window.open(urlSrc);}
	////	MP3 / VIDEO
	else if(/(mp3|mp4|webm)$/i.test(urlSrc))
	{
		//MP3 OU VIDEO (tester aussi en responsive!)
		if(/mp3$/i.test(urlSrc))	{var lightboxSrc='<div style="padding:45px;"><audio id="lightboxMedia" controls controlsList="nodownload"><source src="'+urlSrc+'" type="audio/mpeg">HTML5 browser is required</audio></div>';}
		else						{var lightboxSrc='<video id="lightboxMedia" controls  controlsList="nodownload" style="max-height:85%;" onclick="this.play()"><source src="'+urlSrc+'" type="video/'+extension(urlSrc)+'">HTML5 browser is required</video>';}
		//Ouverture du player Audio/Video
		$.fancybox.open({
			type:"inline",
			src:lightboxSrc,
			opts:{
				buttons:['close'],//Affiche uniquement le bouton "close"
				afterShow:function(){
					$.fancybox.getInstance().update();//Redimentionne le lightbox
					$("#lightboxMedia").get(0).play();//Lance la lecture auto
				}
			}
		});
	}
	////	IFRAME
	else
	{
		$.fancybox.open({
			type:"iframe",
			src:urlSrc,
			opts:{
				animationDuration: 200,			//Temps d'ouverture/fermeture du lightbox
				animationEffect: "zoom-in-out",	//Animation en sortie de lightbox
				buttons:['close'],				//Affiche uniquement le bouton "close"
				beforeShow:function(){
					$(".fancybox-inner").css("visibility","hidden");//Masque le contenu avant de redimensionner le lightbox
				},
				afterShow:function(){
					this.width=$(".fancybox-iframe").contents().find("body").width();	//Récupère le width du "body" du lightbox  : cf. "lightboxSetWidth()"
					$.fancybox.getInstance().update();									//Redimentionne le lightbox du Width
					$(".fancybox-inner").css("visibility","visible");					//Raffiche le contenu, masqué précédement
				},
				beforeClose:function(){
					//On annule la fermeture d'un formulaire en cours d'édition ?
					if(dontConfirmCloseForm())  {return false;}
				}
			}
		});
	}
}

/*
 * Width d'une Lightbox : appelé depuis une lightbox!
 */
function lightboxSetWidth(pageWidth)
{
	$(function(){
		if(find("px",pageWidth))		{pageWidth=pageWidth.replace("px","");}									//Width toujours en pixel
		else if(find("%",pageWidth))	{pageWidth=($(window.parent).width()/100) * pageWidth.replace("%","");}	//Idem
		if(pageWidth>$(window.parent).width())  {pageWidth=$(window.parent).width();}							//Width du contenu > Width de la page : le width devient celui de la page "parent"
		if(isEmptyValue(pageWidth)==false)  {$("body").css("width",pageWidth);}									//Définie le width de la page dans le body : "update" du fancybox  appliqué au moment de l'affichage
	});
}

/*
 * Agrandit si besoin la hauteur d'une Lightbox : suite à un fadeIn() ou autre (avec "duration" de 100ms)
 */
function lightboxResize(forceResize)
{
	//Page déjà chargée && Lancé depuis une lightbox
	if(alreadyLoadedPage() && parent.$(".fancybox-container").is(":visible"))
	{
		//Hauteur du LightBox au début des "fadeIn" and co
		lightboxHeightOld=(inIframe())  ?  parent.$(".fancybox-iframe").contents().height()  :  $(".fancybox-inner").contents().height();
		//Réinit le "setTimeout" si besoin : pas de cumul
		if(typeof lightboxResizeTimeout!="undefined")  {clearTimeout(lightboxResizeTimeout);}//annule le dernier "setTimeout" (pas de cumul)
		//Lance l'update si le contenu est plus grand, avec "setTimeout()" le temps qu'agissent les "fadeIn" and co
		lightboxResizeTimeout=setTimeout(function(){
			var lightboxHeightNew=(inIframe())  ?  parent.$(".fancybox-iframe").contents().height()  :  $(".fancybox-inner").contents().height();
			if((lightboxHeightOld < lightboxHeightNew || forceResize===true) && parent.$.fancybox)  {parent.$.fancybox.getInstance().update();}
		},300);
	}
}

/*
 * Afficher un "prompt" via le lightbox
 */
function lightboxPrompt(promptLabel, actionJS, inputType, defaultValue)
{
	if(isEmptyValue(inputType))		{inputType="text";}//"text" ou "password"
	if(isEmptyValue(defaultValue))	{defaultValue="";}//valeur par défaut dans l'input
	// Construit le formulaire
	var promptForm= "<div style='padding:40px'>\n\
						<div class='lightboxTitle'>"+promptLabel+"</div>\n\
						<input type='"+inputType+"' class='promptInputText' value=\""+defaultValue+"\" onkeydown=\"if(event.keyCode==13){"+actionJS+"}\"> &nbsp;\n\
						<button type='button' onclick=\"if($('.promptInputText').isEmpty()==false){"+actionJS+"}\">OK</button>\n\
					</div>";
	// Affiche le prompt et met le focus sur l'input
	$.fancybox.open({type:"inline", src:promptForm});
	setTimeout(function(){
		$.fancybox.getInstance().update();
		$(".promptInputText").focus();//decalé, s'il y a au autre focus avant (cf. page de connexion)
	},300);
}

/*
 * Ferme le lightbox & reload si besoin la page principale (appelé depuis le lightbox)
 */
function lightboxClose(reloadParentPage, reloadSpecificUrl, urlMsgNotif)
{
	//Reload la page principale ? Url => passé en paramètre OU .parent (lightbox)
	var reloadUrl=null;
	if(reloadParentPage===true){
		reloadUrl=(isEmptyValue(reloadSpecificUrl)==false)  ?  reloadSpecificUrl  :  window.parent.location.href;	//Url passée en parametre OU Url de "parent"
		if(find("msgNotif",reloadUrl))	{reloadUrl=reloadUrl.substring(0,reloadUrl.indexOf('&msgNotif'));}			//Enlève si besoin le parametre "msgNotif" de l'url
		if(!isEmptyValue(urlMsgNotif))	{reloadUrl+=urlMsgNotif;}													//Au besoin, ajoute le nouveau parametre "msgNotif"
	}
	//Ferme le lightbox
	if(isEmptyValue(reloadUrl)==false)	{window.parent.location.replace(reloadUrl);}
	else								{parent.jQuery.fancybox.getInstance().close();}
}

/*
 * Navigation sur appareil tactile (fonctions php & js identiques & css=1005px max)
 */
function isMobile()
{
	return (/android|iphone|ipad|blackberry|windows phone|tablet|touch/i.test(navigator.userAgent)	||	parent.document.body.clientWidth<=1005);
}

/*
 * Version obsolete d'IE ?
 */
function isObsoleteIE()
{
	var vBrowser=navigator.appVersion;
	return (find("MSIE 5.",vBrowser) || find("MSIE 6.",vBrowser) || find("MSIE 7.",vBrowser) || find("MSIE 8.",vBrowser));
}

/*
 * Confirmer une suppression puis rediriger pour effectuer la suppresion
 */
function confirmDelete(redirUrl, labelConfirmDeleteDbl, ajaxControlUrl, ajaxConfirmLabel)
{
	//Effectue un controle Ajax?
	if(isEmptyValue(ajaxControlUrl)==false){
		var ajaxResult=$.ajax({url:ajaxControlUrl,async:false}).responseText;//Attend la réponse Ajax pour passer à la suite (async:false)
		if(ajaxResult!="true" && confirm(ajaxConfirmLabel)==false)	{return false;}//exple : "Attention! certains sous-dossiers ne vous sont pas accessibles en lecture.."
	}
	//Lance la suppression? ("labelConfirmDelete" : cf. "VueStructure.php")
	if(confirm(labelConfirmDelete)){
		if(isEmptyValue(labelConfirmDeleteDbl)==false && confirm(labelConfirmDeleteDbl)==false)  {return false;}
		redir(redirUrl);
	}
}

/*
 * Scroll vers un element OU en bas de page
 */
function toScroll(thisSelector)
{
	//Scroll si la page ne vient pas d'être chargé
	if(alreadyLoadedPage()){
		var heightReference=(typeof thisSelector!="undefined" && $(thisSelector).exist())  ?  $(thisSelector).position().top  :  $(document).height();
		$("html,body").animate({scrollTop:heightReference},100);
	}
}

/*
 * Extension d'un fichier (sans le point!)
 */
function extension(fileName)
{
	if(isEmptyValue(fileName)==false)	{return fileName.split('.').pop().toLowerCase();}
}

/*
 * Vérifie si une chaine est au format Json (cf. Omnispace)
 */
function isJsonString(string)
{
	try{
		JSON.parse(string);
	}catch(e){
		return false;
	}
	return true;
}

/*
 * Vérifie si une valeure est "empty" (équivalent à php)
 */
function isEmptyValue(value)
{
	return (value==null || typeof value=="undefined" || value=="" || value==0);
}

/*
 * La page ne vient pas d'être chargée à l'instant
 */
function alreadyLoadedPage()
{
	return ((Date.now()-pageLoadTimestamp)>1500);//1500ms minimum!
}


/***************************************************************************************************************************/
/*******************************************	SPECIFIC FUNCTIONS	********************************************************/
/***************************************************************************************************************************/


/*
 * Contrôle de connexion à l'agora
 */
function controlConnect()
{
	var inputLogin=$("[name=connectLogin]");
	var inputPassword=$("[name=connectPassword]");
	if(inputLogin.isEmpty() || inputLogin.val()==inputLogin.attr("placeholder") || inputPassword.isEmpty() || inputPassword.val()==inputPassword.attr("placeholder")){
		notify(labelSpecifyLoginPassword);
		return false;
	}
}

/*
 * PAGE INIT : Initialise l'affichage des pages principales
 * => Menu flottant / Largeur des blocks d'objet / Clic sur les blocks d'objet / Etc.
 */
function mainPageDisplay()
{
	////	Largeur des objets en affichage "block", en fonction de la largeur de la page
	if($(".objBlocks .objContainer").length>0)
	{
		//Marge & Largeur min/max des objets
		var objMargin=parseInt($(".objContainer").css("margin-right"))+1;
		var objMinWidth=parseInt($(".objContainer").css("min-width"));
		var objMaxWidth=parseInt($(".objContainer").css("max-width")) + objMargin;//ajoute la marge pour l'application du "width()"
		//Largeur disponible
		var containerWidth=$(".pageFullContent").width();//pas de "innerWidth()" car cela ajoute le "padding"
		if(isMobile()==false && $(document).height()==$(window).height())	{containerWidth=containerWidth-18;}//pas encore d'ascenseur : anticipe son apparition (sauf en responsive ou l'ascenseur est masqué)
		//Calcul la largeur des objets
		var objWidth=null;
		var lineNbObjects=Math.ceil(containerWidth / objMaxWidth);//Nb maxi d'objets par ligne
		if(containerWidth < (objMinWidth*2))				{objWidth=containerWidth;  $(".objContainer").css("max-width",containerWidth);}	//On peut afficher qu'un objet par ligne : il prendra la largeur du conteneur
		else if($(".objContainer").length<lineNbObjects)	{objWidth=objMaxWidth;}															//Nb d'objets insuffisant pour remplir la 1ère ligne : il prendra sa largeur maxi
		else												{objWidth=Math.floor(containerWidth/lineNbObjects);}							//Sinon on calcul : fonction du conteneur et du nb d'objets par ligne
		//Applique la largeur des blocks (enlève le margin: pas pris en compte par le "outerWidth")  &&  Rend visible si ce n'est pas le cas !!
		$(".objContainer").outerWidth(Math.round(objWidth-objMargin)+"px");
	}
	//Raffiche après calcul ci-dessus du width des ".objContainer" (".objBlocks" masqués par défaut via "common.css")
	$(".objBlocks").css("visibility","visible");

	////	Click/DblClick sur les blocks conteneurs des objets (l'id du block doit commencer par "objBlock_")
	if($(".objContainer").exist())
	{
		//Pas sur mobile
		if(isMobile()==false)
		{
			$(".objContainer").click(function(){
				//Init
				var blockId="#"+this.id;
				timeDblClick=400;//intervalle entre 2 clics
				if(typeof timeLastClick=="undefined")	{timeLastClick=Date.now();  containerIdLastClick=this.id;}
				//Double click?
				diffNowAndLastClick=(Date.now()-timeLastClick);
				var isDblClick=(diffNowAndLastClick>10 && diffNowAndLastClick<timeDblClick && containerIdLastClick==this.id);
				//Action sur l'objet
				if(isDblClick==true && $(blockId).attr("data-urlEdit"))		{lightboxOpen($(blockId).attr("data-urlEdit"));}//dblClick + "data-urlEdit" => édition d'objet
				else if(isDblClick==false && typeof objSelect=="function")	{objSelect(this.id);}							//click + fonction "objSelect()" => lance la fonction (cf. "VueObjMenuSelection.php")
				//Update "lastClickTime" & "containerIdLastClick"
				timeLastClick=Date.now();
				containerIdLastClick=this.id;
			});
		}
	}

	////	Menu flottant du module (à gauche)
	if(isMobile()==false && $(".pageModMenuContainer").exist())
	{
		var pageMenuPos=$(".pageModMenuContainer").position();
		$(window).scroll(function(){
			var pageMenuHeight=pageMenuPos.top;//Init la position top du menu
			$(".pageModMenuContainer").children().each(function(){ pageMenuHeight+=$(this).outerHeight(true); });//hauteur de chaque element
			if(pageMenuHeight < $(window).height())  {$(".pageModMenuContainer").css("padding-top",$(window).scrollTop()+"px");}
		});
	}

	////	Fancybox des images & Visibilite des objets & du footer (finalise l'affichage)
	var fancyboxButtons=(isMobile()) ? ['close'] : ['fullScreen','thumbs','close'];
	$("[data-fancybox='images']").fancybox({buttons:fancyboxButtons});
	$("#pageFooterHtml").css("max-width", parseInt($(window).width()-$("#pageFooterIcon").width()-20));//Pour que "pageFooterHtml" ne se superpose pas à "pageFooterIcon"
	setTimeout(function(){  $(".pageFull,.pageCenter").css("margin-bottom",footerHeight());  },100);//Marge sous le contenu pour qu'il ne soit pas masqué par le Footer. Timeout car pour récupérer "footerHeight()" il faut que le "#livecounterMain" soit chargé via Ajax..

	////	MOD CALENDAR : "pulsate" sur les confirm. d'evt
	$(".confirmEventLib").effect("pulsate",{times:50},50000);

	////	Resize de la page : relance récursivement la fonction "mainPageDisplay()"
	if(!isMobile() && !alreadyLoadedPage()){
		$(window).resize(function(){
			if(typeof debounceTimer!="undefined")  {clearTimeout(debounceTimer);}//annule le dernier "setTimeout" (pas de cumul)
			debounceTimer=setTimeout(function(){ mainPageDisplay(); },500);
		});
	}
}

/*
 * Calcul la hauteur disponible pour le contenu principal de la page
 */
function availableContentHeight()
{
	//Height de la fenêtre (mais pas la page), moins la Position "top" du conteneur, moins le paddingTop du conteneur, moins le paddingBottom du conteneur, moins le Height du footer
	var containerSelectors=".pageCenterContent,.pageFullContent,.emptyContainer";
	return Math.round($(window).height() - $(containerSelectors).offset().top - parseInt($(containerSelectors).css("padding-top")) - parseInt($(containerSelectors).css("padding-bottom")) - footerHeight());
}

/*
 * Calcul la hauteur du footer
 */
function footerHeight()
{
	//Icone du footer / Text html du footer  /  LivecounterMain (recup la hauteur préétablie via CSS, le contenu du livecounter est chargé après via Ajax)
	var footerHeightTmp=0;
	$("#pageFooterHtml:visible,#pageFooterIcon:visible,#livecounterMain:visible").each(function(){
		if($(this).html().length>0 && footerHeightTmp<$(this).outerHeight(true))  {footerHeightTmp=$(this).outerHeight(true);}//controle la length, car le "pageFooterHtml" peut être vide mais affiché..
	});
	return footerHeightTmp;
}

/*
 * Confirmation (ou pas) d'événement
 */
function confirmEventProposition(_idCal, _idEvt, divId)
{
	//Init
	var confirmed=false;
	var ajaxUrl="?ctrl=calendar&action=confirmEventProposition&targetObjId=calendar-"+_idCal+"&_idEvt="+_idEvt;
	//Demande de confirmation
	if(confirm(labelEvtConfirm))			{ajaxUrl+="&confirmed=1";  confirmed=true;}
	else if(confirm(labelEvtConfirmNot))	{ajaxUrl+="&confirmed=0";  confirmed=true;}
	//Lance la requête en Ajax
	if(confirmed==true){
		$.ajax(ajaxUrl).done(function(ajaxResult){
			//erreur ajax  ||  recharge la page et le calendrier  ||  supprime la proposition du menu
			if(find("true",ajaxResult)==false)	{notify("Confirm event proposition error");}
			else if(getUrlParam("ctrl",window.location.href)=="calendar")  {redir("?ctrl=calendar");}
			else{
				$("#"+divId).hide();
				if($(".confirmEventProposition").is(":visible")==false)  {$(".confirmEventLib").hide();}
			}
		});
	}
}

/*
 * Affectations des Spaces<->Users : userEdit OU spaceEdit (Click de Label/Checkbox)
 */
function initSpaceAffectations()
{
	//Click de Label
	$(".spaceAffectTable label").click(function(){
		//init
		var _idTarget=this.id.replace("target","");
		var box1="[name='spaceAffect[]'][value='"+_idTarget+"_1']";
		var box2="[name='spaceAffect[]'][value='"+_idTarget+"_2']";
		//Bascule les checkboxes
		var boxToCheck=null;
		if(!$(box1).prop("disabled") && !$(box1).prop("checked") && !$(box2).prop("checked"))	{boxToCheck=box1;}
		else if($(box1).prop("checked") && !$(box2).prop("checked"))							{boxToCheck=box2;}
		//Uncheck les boxes (sauf si disabled), Check celle sélectionnée
		$("[name='spaceAffect[]'][value^='"+_idTarget+"_']").not(":disabled[name='spaceAffect[]']").prop("checked",false);
		if(boxToCheck!=null)	$(boxToCheck).prop("checked",true);
		//Style des labels
		spaceAffectStyle();
	});
	//Click de Checkbox
	$(".spaceAffectTable :checkbox").change(function(){
		var _idTarget=$(this).val().slice(0, $(this).val().lastIndexOf("_"));//exple "1_2" => "1"
		$("[name='spaceAffect[]'][value^='"+_idTarget+"_']").not(this).not(":disabled[name='spaceAffect[]']").prop("checked",false);//"uncheck" les autres checkbox du "target"
		spaceAffectStyle();//Style des labels
	});
	//Init le style des labels
	spaceAffectStyle();
};

/*
 * Applique un style aux labels avec une checkbox cochée
 */
function spaceAffectStyle()
{
	//Réinit le style des labels et rows
	$(".spaceAffectTable label").removeClass("sAccessRead sAccessWrite");
	$(".spaceAffectRow").removeClass("sTableRowSelect");
	//Stylise les labels && la ligne sélectionnées
	$("[name='spaceAffect[]']:checked").each(function(){
		//récupère l'id de la cible && le droit d'accès associé à la box
		var targetRight=this.value.split('_').pop();
		var targetId=this.value.replace('_'+targetRight, '');
		//Stylise le label et la ligne
		if(targetRight=="2")		{$("#target"+targetId).addClass("sAccessWrite");}
		else if(targetRight=="1")	{$("#target"+targetId).addClass("sAccessRead");}
		$("#rowTarget"+targetId).addClass("sTableRowSelect");
	});
}

/*
 * Récupère dans une Url la valeur d'un parametre
 */
function getUrlParam(paramName, url)
{
	paramName=paramName.replace(/[\[\]]/g, "\\$&");
	var regex=new RegExp("[?&]"+paramName+"(=([^&#]*)|&|#|$)");
	var results=regex.exec(url);
	if(!results)			{return null;}
	else if(!results[2])	{return '';}
	else					{return decodeURIComponent(results[2].replace(/\+/g," "));}
}

/*
 * Valide le "like"/"dontlike" d'un objet
 */
function usersLikeValidate(targetObjId, likeValue)
{
	if(isEmptyValue(targetObjId)==false && isEmptyValue(likeValue)==false)
	{
		//Requête Ajax
		$.getJSON("?ctrl=object&action=UsersLikeValidate&targetObjId="+targetObjId+"&likeValue="+likeValue).done(function(jsonResult){
			//Init les id
			var idLike			="#likeMenu_"+targetObjId+"_like";
			var idDontlike		="#likeMenu_"+targetObjId+"_dontlike";
			var idCircleLike    =idLike+" .objMiscMenuCircle";
			var idCircleDontlike=idDontlike+" .objMiscMenuCircle";
			//Nb de likes/dontlikes dans les cercles
			$(idCircleLike+", "+idCircleDontlike).addClass("objMiscMenuCircleHide");//Réinit (Masque par défaut)
			if(parseInt(jsonResult.nbLikes)>0)		{$(idCircleLike).removeClass("objMiscMenuCircleHide").html(jsonResult.nbLikes);}
			if(parseInt(jsonResult.nbDontlikes)>0)	{$(idCircleDontlike).removeClass("objMiscMenuCircleHide").html(jsonResult.nbDontlikes);}
			//Liste des users dans les tooltip/title
			$(idLike).tooltipster("destroy").attr("title",jsonResult.usersLikeList).tooltipster(tooltipsterOptions);
			$(idDontlike).tooltipster("destroy").attr("title",jsonResult.usersDontlikeList).tooltipster(tooltipsterOptions);
			//Fait clignoter le like/dontlike  &&  affiche le tooltip (trigger mouseover)
			var menuId=(likeValue=="like") ? idLike : idDontlike;
			$(menuId).effect("pulsate",{times:1},300).trigger("mouseover");
			//Enlève/Ajoute l'opacité du menu (affichage Block, cf. css)
			if(jsonResult.nbLikes>0 || jsonResult.nbDontlikes>0)	{$(menuId).parent().removeClass("hideMiscMenu");}
			else													{$(menuId).parent().addClass("hideMiscMenu");}
		});
	}
}